`timescale 1ns / 1ps
module tdo_mux(
  input TCK,
  input TDO_0C,
  input TDO_17,
  input [31:0] FSEL,
  output reg TDO);

  
  always @(negedge TCK)
		 case (FSEL)
		    32'h00001000: TDO <= TDO_0C;
		    32'h00800000: TDO <= TDO_17;
		    default: TDO <= 1'b0;
		 endcase
  
  
endmodule
