-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Tue Jan 18 22:54:46 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_error_cnt_mod IS 
	PORT
	(
		ec_test :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		tx_seu :  IN  STD_LOGIC;
		tx_fs_seu :  IN  STD_LOGIC;
		tx_dwf_seu :  IN  STD_LOGIC;
		tx_dwf_deu :  IN  STD_LOGIC;
		tx_fdf_seu :  IN  STD_LOGIC;
		tx_fdf_deu :  IN  STD_LOGIC;
		rx_seu :  IN  STD_LOGIC;
		rx_fs_seu :  IN  STD_LOGIC;
		rx_dwf_seu :  IN  STD_LOGIC;
		rx_dwf_deu :  IN  STD_LOGIC;
		rx_fdf_seu :  IN  STD_LOGIC;
		rx_fdf_deu :  IN  STD_LOGIC;
		rx_sl :  IN  STD_LOGIC;
		rx_ths_seu :  IN  STD_LOGIC;
		rx_fd_seu :  IN  STD_LOGIC;
		rx_fd_deu :  IN  STD_LOGIC;
		ec_enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ec_reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ec_sel_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_sel_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_sel_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_test_en :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ec_out_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_out_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_out_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_test_out_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_test_out_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_test_out_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		rx_dwf_deu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_dwf_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_fd_deu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_fd_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_fdf_deu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_fdf_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_fs_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_sl_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_ths_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_dwf_deu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_dwf_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_fdf_deu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_fdf_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_fs_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_seu_ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END ff_emu_error_cnt_mod;

ARCHITECTURE bdf_type OF ff_emu_error_cnt_mod IS 

COMPONENT decode_16
	PORT(enable : IN STD_LOGIC;
		 data : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 eq_00 : OUT STD_LOGIC;
		 eq_01 : OUT STD_LOGIC;
		 eq_02 : OUT STD_LOGIC;
		 eq_03 : OUT STD_LOGIC;
		 eq_04 : OUT STD_LOGIC;
		 eq_05 : OUT STD_LOGIC;
		 eq_06 : OUT STD_LOGIC;
		 eq_07 : OUT STD_LOGIC;
		 eq_08 : OUT STD_LOGIC;
		 eq_09 : OUT STD_LOGIC;
		 eq_10 : OUT STD_LOGIC;
		 eq_11 : OUT STD_LOGIC;
		 eq_12 : OUT STD_LOGIC;
		 eq_13 : OUT STD_LOGIC;
		 eq_14 : OUT STD_LOGIC;
		 eq_15 : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT mux_16xn
GENERIC (n : INTEGER
			);
	PORT(data00 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data01 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data02 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data03 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data04 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data05 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data06 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data07 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data08 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data09 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data10 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data11 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data12 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data13 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data14 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data15 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 sel : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT error_cnt_secdecset
	PORT(clk : IN STD_LOGIC;
		 error_a : IN STD_LOGIC;
		 error_b : IN STD_LOGIC;
		 error_c : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ec_cnt_out_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_cnt_out_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_cnt_out_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT ff_emu_error_cnt_en_gen
	PORT(ec_test : IN STD_LOGIC;
		 error : IN STD_LOGIC;
		 ec_test_en : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ec_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT error_stretch
	PORT(clk : IN STD_LOGIC;
		 error_in : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 error_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ec_out_a_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_out_b_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_out_c_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_deu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_deu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_deu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_dwf_deu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_dwf_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_dwf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_dwf_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_deu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_deu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_deu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_deu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fd_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_deu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_deu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_deu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_deu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fdf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fs_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fs_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fs_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_fs_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fs_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_sl_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_sl_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_sl_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_sl_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_sl_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_ths_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_ths_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_ths_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	rx_ths_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_ths_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_dwf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_dwf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_fd_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_fd_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_fdf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_fdf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_fs_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_sl_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_rx_ths_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_dwf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_dwf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_fdf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_fdf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_fs_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	t_tx_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_dwf_deu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_deu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_deu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_dwf_deu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_dwf_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_dwf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_dwf_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_deu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_deu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_deu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_deu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_deu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fdf_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fs_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fs_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fs_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_fs_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fs_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_seu_ec_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_seu_ec_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_seu_ec_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tx_seu_ec_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_seu_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_EC_DEC_A : decode_16
PORT MAP(enable => ec_test_en(0),
		 data => ec_sel_a(3 DOWNTO 0),
		 eq_00 => tx_seu_ec_test_en(0),
		 eq_01 => tx_fs_seu_ec_test_en(0),
		 eq_02 => tx_dwf_seu_ec_test_en(0),
		 eq_03 => tx_dwf_deu_ec_test_en(0),
		 eq_04 => tx_fdf_seu_ec_test_en(0),
		 eq_05 => tx_fdf_deu_ec_test_en(0),
		 eq_06 => rx_seu_ec_test_en(0),
		 eq_07 => rx_fs_seu_ec_test_en(0),
		 eq_08 => rx_dwf_seu_ec_test_en(0),
		 eq_09 => rx_dwf_deu_ec_test_en(0),
		 eq_10 => rx_fdf_seu_ec_test_en(0),
		 eq_11 => rx_fdf_deu_ec_test_en(0),
		 eq_12 => rx_sl_ec_test_en(0),
		 eq_13 => rx_ths_seu_ec_test_en(0),
		 eq_14 => rx_fd_seu_ec_test_en(0),
		 eq_15 => rx_fd_deu_ec_test_en(0));


b2v_EC_DEC_B : decode_16
PORT MAP(enable => ec_test_en(1),
		 data => ec_sel_b(3 DOWNTO 0),
		 eq_00 => tx_seu_ec_test_en(1),
		 eq_01 => tx_fs_seu_ec_test_en(1),
		 eq_02 => tx_dwf_seu_ec_test_en(1),
		 eq_03 => tx_dwf_deu_ec_test_en(1),
		 eq_04 => tx_fdf_seu_ec_test_en(1),
		 eq_05 => tx_fdf_deu_ec_test_en(1),
		 eq_06 => rx_seu_ec_test_en(1),
		 eq_07 => rx_fs_seu_ec_test_en(1),
		 eq_08 => rx_dwf_seu_ec_test_en(1),
		 eq_09 => rx_dwf_deu_ec_test_en(1),
		 eq_10 => rx_fdf_seu_ec_test_en(1),
		 eq_11 => rx_fdf_deu_ec_test_en(1),
		 eq_12 => rx_sl_ec_test_en(1),
		 eq_13 => rx_ths_seu_ec_test_en(1),
		 eq_14 => rx_fd_seu_ec_test_en(1),
		 eq_15 => rx_fd_deu_ec_test_en(1));


b2v_EC_DEC_C : decode_16
PORT MAP(enable => ec_test_en(2),
		 data => ec_sel_c(3 DOWNTO 0),
		 eq_00 => tx_seu_ec_test_en(2),
		 eq_01 => tx_fs_seu_ec_test_en(2),
		 eq_02 => tx_dwf_seu_ec_test_en(2),
		 eq_03 => tx_dwf_deu_ec_test_en(2),
		 eq_04 => tx_fdf_seu_ec_test_en(2),
		 eq_05 => tx_fdf_deu_ec_test_en(2),
		 eq_06 => rx_seu_ec_test_en(2),
		 eq_07 => rx_fs_seu_ec_test_en(2),
		 eq_08 => rx_dwf_seu_ec_test_en(2),
		 eq_09 => rx_dwf_deu_ec_test_en(2),
		 eq_10 => rx_fdf_seu_ec_test_en(2),
		 eq_11 => rx_fdf_deu_ec_test_en(2),
		 eq_12 => rx_sl_ec_test_en(2),
		 eq_13 => rx_ths_seu_ec_test_en(2),
		 eq_14 => rx_fd_seu_ec_test_en(2),
		 eq_15 => rx_fd_deu_ec_test_en(2));


b2v_EC_MUX_A : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => tx_seu_ec_a,
		 data01 => tx_fs_seu_ec_a,
		 data02 => tx_dwf_seu_ec_a,
		 data03 => tx_dwf_deu_ec_a,
		 data04 => tx_fdf_seu_ec_a,
		 data05 => tx_fdf_deu_ec_a,
		 data06 => rx_seu_ec_a,
		 data07 => rx_fs_seu_ec_a,
		 data08 => rx_dwf_seu_ec_a,
		 data09 => rx_dwf_deu_ec_a,
		 data10 => rx_fdf_seu_ec_a,
		 data11 => rx_fdf_deu_ec_a,
		 data12 => rx_sl_ec_a,
		 data13 => rx_ths_seu_ec_a,
		 data14 => rx_fd_seu_ec_a,
		 data15 => rx_fd_deu_ec_a,
		 sel => ec_sel_a(3 DOWNTO 0),
		 result => ec_out_a_ALTERA_SYNTHESIZED);


b2v_EC_MUX_B : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => tx_seu_ec_b,
		 data01 => tx_fs_seu_ec_b,
		 data02 => tx_dwf_seu_ec_b,
		 data03 => tx_dwf_deu_ec_b,
		 data04 => tx_fdf_seu_ec_b,
		 data05 => tx_fdf_deu_ec_b,
		 data06 => rx_seu_ec_b,
		 data07 => rx_fs_seu_ec_b,
		 data08 => rx_dwf_seu_ec_b,
		 data09 => rx_dwf_deu_ec_b,
		 data10 => rx_fdf_seu_ec_b,
		 data11 => rx_fdf_deu_ec_b,
		 data12 => rx_sl_ec_b,
		 data13 => rx_ths_seu_ec_b,
		 data14 => rx_fd_seu_ec_b,
		 data15 => rx_fd_deu_ec_b,
		 sel => ec_sel_b(3 DOWNTO 0),
		 result => ec_out_b_ALTERA_SYNTHESIZED);


b2v_EC_MUX_C : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => tx_seu_ec_c,
		 data01 => tx_fs_seu_ec_c,
		 data02 => tx_dwf_seu_ec_c,
		 data03 => tx_dwf_deu_ec_c,
		 data04 => tx_fdf_seu_ec_c,
		 data05 => tx_fdf_deu_ec_c,
		 data06 => rx_seu_ec_c,
		 data07 => rx_fs_seu_ec_c,
		 data08 => rx_dwf_seu_ec_c,
		 data09 => rx_dwf_deu_ec_c,
		 data10 => rx_fdf_seu_ec_c,
		 data11 => rx_fdf_deu_ec_c,
		 data12 => rx_sl_ec_c,
		 data13 => rx_ths_seu_ec_c,
		 data14 => rx_fd_seu_ec_c,
		 data15 => rx_fd_deu_ec_c,
		 sel => ec_sel_c(3 DOWNTO 0),
		 result => ec_out_c_ALTERA_SYNTHESIZED);

ec_test_out_a <= ec_out_a_ALTERA_SYNTHESIZED;


ec_test_out_b <= ec_out_b_ALTERA_SYNTHESIZED;


ec_test_out_c <= ec_out_c_ALTERA_SYNTHESIZED;



b2v_RX_DWF_DEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_dwf_deu_ec_en(0),
		 error_b => rx_dwf_deu_ec_en(1),
		 error_c => rx_dwf_deu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_dwf_deu_ec_a,
		 ec_cnt_out_b => rx_dwf_deu_ec_b,
		 ec_cnt_out_c => rx_dwf_deu_ec_c,
		 ef => rx_dwf_deu_ef);


b2v_RX_DWF_DEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_dwf_deu,
		 ec_test_en => rx_dwf_deu_ec_test_en,
		 ec_en => t_rx_dwf_deu_ec_en);


b2v_RX_DWF_DEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_dwf_deu_ec_en,
		 reset => ec_reset,
		 error_out => rx_dwf_deu_ec_en);


b2v_RX_DWF_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_dwf_seu_ec_en(0),
		 error_b => rx_dwf_seu_ec_en(1),
		 error_c => rx_dwf_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_dwf_seu_ec_a,
		 ec_cnt_out_b => rx_dwf_seu_ec_b,
		 ec_cnt_out_c => rx_dwf_seu_ec_c,
		 ef => rx_dwf_seu_ef);


b2v_RX_DWF_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_dwf_seu,
		 ec_test_en => rx_dwf_seu_ec_test_en,
		 ec_en => t_rx_dwf_seu_ec_en);


b2v_RX_DWF_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_dwf_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_dwf_seu_ec_en);


b2v_RX_FD_DEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_fd_deu_ec_en(0),
		 error_b => rx_fd_deu_ec_en(1),
		 error_c => rx_fd_deu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_fd_deu_ec_a,
		 ec_cnt_out_b => rx_fd_deu_ec_b,
		 ec_cnt_out_c => rx_fd_deu_ec_c,
		 ef => rx_fd_deu_ef);


b2v_RX_FD_DEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_fd_deu,
		 ec_test_en => rx_fd_deu_ec_test_en,
		 ec_en => t_rx_fd_deu_ec_en);


b2v_RX_FD_DEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_fd_deu_ec_en,
		 reset => ec_reset,
		 error_out => rx_fd_deu_ec_en);


b2v_RX_FD_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_fd_seu_ec_en(0),
		 error_b => rx_fd_seu_ec_en(1),
		 error_c => rx_fd_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_fd_seu_ec_a,
		 ec_cnt_out_b => rx_fd_seu_ec_b,
		 ec_cnt_out_c => rx_fd_seu_ec_c,
		 ef => rx_fd_seu_ef);


b2v_RX_FD_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_fd_seu,
		 ec_test_en => rx_fd_seu_ec_test_en,
		 ec_en => t_rx_fd_seu_ec_en);


b2v_RX_FD_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_fd_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_fd_seu_ec_en);


b2v_RX_FDF_DEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_fdf_deu_ec_en(0),
		 error_b => rx_fdf_deu_ec_en(1),
		 error_c => rx_fdf_deu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_fdf_deu_ec_a,
		 ec_cnt_out_b => rx_fdf_deu_ec_b,
		 ec_cnt_out_c => rx_fdf_deu_ec_c,
		 ef => rx_fdf_deu_ef);


b2v_RX_FDF_DEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_fdf_deu,
		 ec_test_en => rx_fdf_deu_ec_test_en,
		 ec_en => t_rx_fdf_deu_ec_en);


b2v_RX_FDF_DEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_fdf_deu_ec_en,
		 reset => ec_reset,
		 error_out => rx_fdf_deu_ec_en);


b2v_RX_FDF_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_fdf_seu_ec_en(0),
		 error_b => rx_fdf_seu_ec_en(1),
		 error_c => rx_fdf_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_fdf_seu_ec_a,
		 ec_cnt_out_b => rx_fdf_seu_ec_b,
		 ec_cnt_out_c => rx_fdf_seu_ec_c,
		 ef => rx_fdf_seu_ef);


b2v_RX_FDF_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_fdf_seu,
		 ec_test_en => rx_fdf_seu_ec_test_en,
		 ec_en => t_rx_fdf_seu_ec_en);


b2v_RX_FDF_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_fdf_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_fdf_seu_ec_en);


b2v_RX_FS_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_fs_seu_ec_en(0),
		 error_b => rx_fs_seu_ec_en(1),
		 error_c => rx_fs_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_fs_seu_ec_a,
		 ec_cnt_out_b => rx_fs_seu_ec_b,
		 ec_cnt_out_c => rx_fs_seu_ec_c,
		 ef => rx_fs_seu_ef);


b2v_RX_FS_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_fs_seu,
		 ec_test_en => rx_fs_seu_ec_test_en,
		 ec_en => t_rx_fs_seu_ec_en);


b2v_RX_FS_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_fs_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_fs_seu_ec_en);


b2v_RX_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_seu_ec_en(0),
		 error_b => rx_seu_ec_en(1),
		 error_c => rx_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_seu_ec_a,
		 ec_cnt_out_b => rx_seu_ec_b,
		 ec_cnt_out_c => rx_seu_ec_c,
		 ef => rx_seu_ef);


b2v_RX_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_seu,
		 ec_test_en => rx_seu_ec_test_en,
		 ec_en => t_rx_seu_ec_en);


b2v_RX_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_seu_ec_en);


b2v_RX_SL_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_sl_ec_en(0),
		 error_b => rx_sl_ec_en(1),
		 error_c => rx_sl_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_sl_ec_a,
		 ec_cnt_out_b => rx_sl_ec_b,
		 ec_cnt_out_c => rx_sl_ec_c,
		 ef => rx_sl_ef);


b2v_RX_SL_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_sl,
		 ec_test_en => rx_sl_ec_test_en,
		 ec_en => t_rx_sl_ec_en);


b2v_RX_SL_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_sl_ec_en,
		 reset => ec_reset,
		 error_out => rx_sl_ec_en);


b2v_RX_THS_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => rx_ths_seu_ec_en(0),
		 error_b => rx_ths_seu_ec_en(1),
		 error_c => rx_ths_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => rx_ths_seu_ec_a,
		 ec_cnt_out_b => rx_ths_seu_ec_b,
		 ec_cnt_out_c => rx_ths_seu_ec_c,
		 ef => rx_ths_seu_ef);


b2v_RX_THS_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => rx_ths_seu,
		 ec_test_en => rx_ths_seu_ec_test_en,
		 ec_en => t_rx_ths_seu_ec_en);


b2v_RX_THS_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_rx_ths_seu_ec_en,
		 reset => ec_reset,
		 error_out => rx_ths_seu_ec_en);


b2v_TX_DWF_DEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_dwf_deu_ec_en(0),
		 error_b => tx_dwf_deu_ec_en(1),
		 error_c => tx_dwf_deu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_dwf_deu_ec_a,
		 ec_cnt_out_b => tx_dwf_deu_ec_b,
		 ec_cnt_out_c => tx_dwf_deu_ec_c,
		 ef => tx_dwf_deu_ef);


b2v_TX_DWF_DEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_dwf_deu,
		 ec_test_en => tx_dwf_deu_ec_test_en,
		 ec_en => t_tx_dwf_deu_ec_en);


b2v_TX_DWF_DEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_dwf_deu_ec_en,
		 reset => ec_reset,
		 error_out => tx_dwf_deu_ec_en);


b2v_TX_DWF_DEU_SM4 : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_fdf_deu_ec_en,
		 reset => ec_reset,
		 error_out => tx_fdf_seu_ec_en);


b2v_TX_DWF_DEU_SM5 : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_fdf_deu_ec_en,
		 reset => ec_reset,
		 error_out => tx_fdf_deu_ec_en);


b2v_TX_DWF_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_dwf_seu_ec_en(0),
		 error_b => tx_dwf_seu_ec_en(1),
		 error_c => tx_dwf_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_dwf_seu_ec_a,
		 ec_cnt_out_b => tx_dwf_seu_ec_b,
		 ec_cnt_out_c => tx_dwf_seu_ec_c,
		 ef => tx_dwf_seu_ef);


b2v_TX_DWF_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_dwf_seu,
		 ec_test_en => tx_dwf_seu_ec_test_en,
		 ec_en => t_tx_dwf_seu_ec_en);


b2v_TX_DWF_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_dwf_seu_ec_en,
		 reset => ec_reset,
		 error_out => tx_dwf_seu_ec_en);


b2v_TX_FDF_DEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_fdf_deu_ec_en(0),
		 error_b => tx_fdf_deu_ec_en(1),
		 error_c => tx_fdf_deu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_fdf_deu_ec_a,
		 ec_cnt_out_b => tx_fdf_deu_ec_b,
		 ec_cnt_out_c => tx_fdf_deu_ec_c,
		 ef => tx_fdf_deu_ef);


b2v_TX_FDF_DEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_fdf_deu,
		 ec_test_en => tx_fdf_deu_ec_test_en,
		 ec_en => t_tx_fdf_deu_ec_en);


b2v_TX_FDF_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_fdf_seu_ec_en(0),
		 error_b => tx_fdf_seu_ec_en(1),
		 error_c => tx_fdf_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_fdf_seu_ec_a,
		 ec_cnt_out_b => tx_fdf_seu_ec_b,
		 ec_cnt_out_c => tx_fdf_seu_ec_c,
		 ef => tx_fdf_seu_ef);


b2v_TX_FDF_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_fdf_seu,
		 ec_test_en => tx_fdf_seu_ec_test_en);


b2v_TX_FS_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_fs_seu_ec_en(0),
		 error_b => tx_fs_seu_ec_en(1),
		 error_c => tx_fs_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_fs_seu_ec_a,
		 ec_cnt_out_b => tx_fs_seu_ec_b,
		 ec_cnt_out_c => tx_fs_seu_ec_c,
		 ef => tx_fs_seu_ef);


b2v_TX_FS_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_fs_seu,
		 ec_test_en => tx_fs_seu_ec_test_en,
		 ec_en => t_tx_fs_seu_ec_en);


b2v_TX_FS_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_fs_seu_ec_en,
		 reset => ec_reset,
		 error_out => tx_fs_seu_ec_en);


b2v_TX_SEU_EC : error_cnt_secdecset
PORT MAP(clk => clk,
		 error_a => tx_seu_ec_en(0),
		 error_b => tx_seu_ec_en(1),
		 error_c => tx_seu_ec_en(2),
		 enable => ec_enable,
		 reset => ec_reset,
		 ec_cnt_out_a => tx_seu_ec_a,
		 ec_cnt_out_b => tx_seu_ec_b,
		 ec_cnt_out_c => tx_seu_ec_c,
		 ef => tx_seu_ef);


b2v_TX_SEU_EC_EG : ff_emu_error_cnt_en_gen
PORT MAP(ec_test => ec_test,
		 error => tx_seu,
		 ec_test_en => tx_seu_ec_test_en,
		 ec_en => t_tx_seu_ec_en);


b2v_TX_SEU_SM : error_stretch
PORT MAP(clk => clk,
		 error_in => t_tx_seu_ec_en,
		 reset => ec_reset,
		 error_out => tx_seu_ec_en);

ec_out_a <= ec_out_a_ALTERA_SYNTHESIZED;
ec_out_b <= ec_out_b_ALTERA_SYNTHESIZED;
ec_out_c <= ec_out_c_ALTERA_SYNTHESIZED;

END bdf_type;