-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 22:22:37 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY hamming_enc IS 
	PORT
	(
		ham_enc_in :  IN  STD_LOGIC_VECTOR(10 DOWNTO 0);
		ham_enc_out :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END hamming_enc;

ARCHITECTURE bdf_type OF hamming_enc IS 

COMPONENT hamming_16_11_encoder
	PORT(word_in : IN STD_LOGIC_VECTOR(10 DOWNTO 0);
		 word_enc : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;



BEGIN 



b2v_inst : hamming_16_11_encoder
PORT MAP(word_in => ham_enc_in,
		 word_enc => ham_enc_out);


END bdf_type;