-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 14:54:55 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY reg_1r_SECDECSET IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		data_a_in :  IN  STD_LOGIC;
		data_b_in :  IN  STD_LOGIC;
		data_c_in :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		data_c_out :  OUT  STD_LOGIC;
		data_b_out :  OUT  STD_LOGIC;
		data_a_out :  OUT  STD_LOGIC
	);
END reg_1r_SECDECSET;

ARCHITECTURE bdf_type OF reg_1r_SECDECSET IS 

COMPONENT reg_1_secdecset_ml
	PORT(data_1_in : IN STD_LOGIC;
		 data_2_in : IN STD_LOGIC;
		 data_3_in : IN STD_LOGIC;
		 data_4_in : IN STD_LOGIC;
		 data_5_in : IN STD_LOGIC;
		 data_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT reg_1r_secdecset_regs
	PORT(clk : IN STD_LOGIC;
		 data_1_in : IN STD_LOGIC;
		 data_2_in : IN STD_LOGIC;
		 data_3_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_1_out : OUT STD_LOGIC;
		 data_2_out : OUT STD_LOGIC;
		 data_3_out : OUT STD_LOGIC;
		 data_4_out : OUT STD_LOGIC;
		 data_5_out : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	data :  STD_LOGIC_VECTOR(4 DOWNTO 0);


BEGIN 



b2v_ML_A : reg_1_secdecset_ml
PORT MAP(data_1_in => data(0),
		 data_2_in => data(1),
		 data_3_in => data(2),
		 data_4_in => data(3),
		 data_5_in => data(4),
		 data_out => data_a_out);


b2v_ML_B : reg_1_secdecset_ml
PORT MAP(data_1_in => data(0),
		 data_2_in => data(1),
		 data_3_in => data(2),
		 data_4_in => data(3),
		 data_5_in => data(4),
		 data_out => data_b_out);


b2v_ML_C : reg_1_secdecset_ml
PORT MAP(data_1_in => data(0),
		 data_2_in => data(1),
		 data_3_in => data(2),
		 data_4_in => data(3),
		 data_5_in => data(4),
		 data_out => data_c_out);


b2v_REGS : reg_1r_secdecset_regs
PORT MAP(clk => clk,
		 data_1_in => data_a_in,
		 data_2_in => data_b_in,
		 data_3_in => data_c_in,
		 enable => enable,
		 reset => reset,
		 data_1_out => data(0),
		 data_2_out => data(1),
		 data_3_out => data(2),
		 data_4_out => data(3),
		 data_5_out => data(4));


END bdf_type;