	   ------------------------------------------------------------------------------------
-- Details:
--		Type: E type flip-flop - synchronous RST_L
------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

entity ffe is
	port (
		d : in std_logic;
		rst_l : in std_logic;
		en : in std_logic;
		clk : in std_logic;
		q : out std_logic
	);
end entity;

architecture ffe_arch of ffe is
begin	 
	
	process (clk)
	begin

		if rising_edge(clk) then
			if rst_l = '0' then
				q <= '0';
			elsif en = '1' then
				q <= d;
			end if;
		end if;

	end process;

end ffe_arch;
