-- Description: Majority Voter

library IEEE;
use IEEE.std_logic_1164.all;


entity fifo_maj_voter is	
	port (
		a : in std_logic;
		b : in std_logic;
		c : in std_logic;
		q : out std_logic
	);
end entity;

architecture fifo_maj_voter_arch of fifo_maj_voter is
begin

	process (a,b,c)
	begin
		if (a = b) and (b = c)  then
			q <= a; 
		elsif (a = b) and (c /= b) then
			q <= a; 
		elsif (b = c) and (a /= b) then
			q <= b; 
-- QUARTUS WARNING	elsif (a = c) and (b /= a) then
		else
			q <= a; 
		end if;
	end process;

end architecture;
