-------------------------------------------------------------------------------
--
-- Title       : THS_cmd_selector
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--
-------------------------------------------------------------------------------
--
-- File        : f:\Cla.CASA-281B942773\Desktop\Ripostiglio\Ing\Tesi\VHDL Projects\Interfaces\Interfaces_04_22\src\THS_cmd_selector.vhd
-- Generated   : Sat Apr 25 16:38:08 2009
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {THS_cmd_selector} architecture {THS_cmd_selector}}

library IEEE;
use IEEE.STD_LOGIC_1164.all; 
use work.interfaces_pkg.all;

entity THS_cmd_selector is
	 port(
		 TRG : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
		 HDR : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
		 SYN : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
		 TRG_cmd : in STD_LOGIC;
		 HDR_cmd : in STD_LOGIC;
		 SYN_cmd : in STD_LOGIC;
		 THS_seq : out STD_LOGIC_VECTOR(N_THS-1 downto 0)
	     );
end THS_cmd_selector;

--}} End of automatically maintained section

architecture THS_cmd_selector of THS_cmd_selector is
begin

THS_seq <= TRG when TRG_cmd = '1' else
	HDR when HDR_cmd = '1' else
	SYN when SYN_cmd = '1' else
	(others => '0');

end THS_cmd_selector;
