-- dec_4b_6b
--
-- 

library IEEE;
use IEEE.std_logic_1164.all;

entity dec_4b_6b is
	port (
		input  : in std_logic_vector(5 downto 0); 
		output : out std_logic_vector(3 downto 0)
	);
end entity;

architecture dec_4b_6b1 of dec_4b_6b is

begin

  process(input)
  begin
    case input is
      when "000111" =>
        output <= x"0";
      when "001101" =>
        output <= x"1";
      when "001110" =>
        output <= x"2";
      when "010011" =>
        output <= x"3";
      when "010110" =>
        output <= x"4";
      when "011001" =>
        output <= x"5";
      when "011010" =>
        output <= x"6";
      when "011100" =>
        output <= x"7";
      when "100011" =>
        output <= x"8";
      when "100101" =>
        output <= x"9";
      when "100110" =>
        output <= x"A";
      when "101001" =>
        output <= x"B";
      when "101100" =>
        output <= x"C";
      when "110001" =>
        output <= x"D";
      when "110010" =>
        output <= x"E";
      when "110100" =>
        output <= x"F";
      when others =>
        output <= x"0";
    end case;
  end process;

end architecture;
