------------------------------------------------------------------------------------
-- Details:
--		Type: Demultiplexer
--		Input and outputs width: 1
--		Number of outputs: 16
--		Defalut output bits value '0'
------------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity dmux_16 is
	port (
		O : out std_logic_vector(15 downto 0);
		S : in std_logic_vector(3 downto 0);
		I : in std_logic
	);
end entity;

library IEEE;
use IEEE.STD_LOGIC_UNSIGNED.all;

architecture dmux_16_arch of dmux_16 is
	constant NON_ACTIVE : std_logic := '0';

begin

	O(0) <= I when (S = 0) else NON_ACTIVE;
	O(1) <= I when (S = 1) else NON_ACTIVE;
	O(2) <= I when (S = 2) else NON_ACTIVE;
	O(3) <= I when (S = 3) else NON_ACTIVE;
	O(4) <= I when (S = 4) else NON_ACTIVE;
	O(5) <= I when (S = 5) else NON_ACTIVE;
	O(6) <= I when (S = 6) else NON_ACTIVE;
	O(7) <= I when (S = 7) else NON_ACTIVE;
	O(8) <= I when (S = 8) else NON_ACTIVE;
	O(9) <= I when (S = 9) else NON_ACTIVE;
	O(10) <= I when (S = 10) else NON_ACTIVE;
	O(11) <= I when (S = 11) else NON_ACTIVE;
	O(12) <= I when (S = 12) else NON_ACTIVE;
	O(13) <= I when (S = 13) else NON_ACTIVE;
	O(14) <= I when (S = 14) else NON_ACTIVE;
	O(15) <= I when (S = 15) else NON_ACTIVE;

end architecture;