------------------------------------------------------------------------------------
-- Details:
--		Type: Demultiplexer
--		Input and outputs width: 1
--		Number of outputs: 4
--		Defalut output bits value '0'
------------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity dmux_4 is
	port (
		O : out std_logic_vector(3 downto 0);
		S : in std_logic_vector(1 downto 0);
		I : in std_logic
	);
end entity;

library IEEE;
use IEEE.STD_LOGIC_UNSIGNED.all;

architecture dmux_4_arch of dmux_4 is
	constant NON_ACTIVE : std_logic := '0';

begin

	O(0) <= I when (S = 0) else NON_ACTIVE;
	O(1) <= I when (S = 1) else NON_ACTIVE;
	O(2) <= I when (S = 2) else NON_ACTIVE;
	O(3) <= I when (S = 3) else NON_ACTIVE;

end architecture;