-- enc_4b_6b
--
-- 

library IEEE;
use IEEE.std_logic_1164.all;

entity enc_4b_6b is
	port (
		input  : in std_logic_vector(3 downto 0); 
		output : out std_logic_vector(5 downto 0)
	);
end entity;

architecture enc_4b_6b1 of enc_4b_6b is

begin
  
  process(input)
  begin
    case input is
      when x"0" =>
        output <= "000111";
      when x"1" =>
        output <= "001101";
      when x"2" =>
        output <= "001110";
      when x"3" =>
        output <= "010011";
      when x"4" =>
        output <= "010110";
      when x"5" =>
        output <= "011001";
      when x"6" =>
        output <= "011010";
      when x"7" =>
        output <= "011100";
      when x"8" =>
        output <= "100011";
      when x"9" =>
        output <= "100101";
      when x"A" =>
        output <= "100110";
      when x"B" =>
        output <= "101001";
      when x"C" =>
        output <= "101100";
      when x"D" =>
        output <= "110001";
      when x"E" =>
        output <= "110010";
      when x"F" =>
        output <= "110100";
      when others =>
        output <= "000000";
    end case;
  end process;
        

end architecture;
