-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Sun Jun 19 09:33:07 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_emu IS 
	PORT
	(
		rx_clk :  IN  STD_LOGIC;
		tx_clk :  IN  STD_LOGIC;
		reset :  IN  STD_LOGIC;
		rx_dat :  IN  STD_LOGIC;
		clk_ref :  IN  STD_LOGIC;
		rx_clk_en :  IN  STD_LOGIC;
		vlf_e1_in :  IN  STD_LOGIC;
		vlf_e2_in :  IN  STD_LOGIC;
		vlf_e3_in :  IN  STD_LOGIC;
		vlf_ta1_in :  IN  STD_LOGIC;
		vlf_ta2_in :  IN  STD_LOGIC;
		vlf_ta3_in :  IN  STD_LOGIC;
		vlf_tb1_in :  IN  STD_LOGIC;
		vlf_tb2_in :  IN  STD_LOGIC;
		flf_p1_in :  IN  STD_LOGIC;
		flf_p2_in :  IN  STD_LOGIC;
		flf_e1_in :  IN  STD_LOGIC;
		flf_e2_in :  IN  STD_LOGIC;
		tx_tkn :  IN  STD_LOGIC;
		tx_scl :  IN  STD_LOGIC;
		tx_sda :  IN  STD_LOGIC;
		reg_init :  IN  STD_LOGIC_VECTOR(8 DOWNTO 0);
		ta_delay :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tb_delay :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tx_dat :  OUT  STD_LOGIC;
		rx_rec_clk :  OUT  STD_LOGIC;
		rx_sync :  OUT  STD_LOGIC;
		rx_resync :  OUT  STD_LOGIC;
		vlf_e1_out :  OUT  STD_LOGIC;
		vlf_e2_out :  OUT  STD_LOGIC;
		vlf_e3_out :  OUT  STD_LOGIC;
		vlf_ta1_out :  OUT  STD_LOGIC;
		vlf_ta2_out :  OUT  STD_LOGIC;
		vlf_ta3_out :  OUT  STD_LOGIC;
		vlf_tb1_out :  OUT  STD_LOGIC;
		vlf_tb2_out :  OUT  STD_LOGIC;
		flf_p1_out :  OUT  STD_LOGIC;
		flf_p2_out :  OUT  STD_LOGIC;
		flf_e2_out :  OUT  STD_LOGIC;
		flf_e1_out :  OUT  STD_LOGIC;
		vlf_dv :  OUT  STD_LOGIC;
		flf_dv :  OUT  STD_LOGIC;
		rx_scl :  OUT  STD_LOGIC;
		rx_tkn :  OUT  STD_LOGIC;
		rx_sda :  OUT  STD_LOGIC
	);
END ff_emu_emu;

ARCHITECTURE bdf_type OF ff_emu_emu IS 

COMPONENT ff_emu_emu_core
	PORT(reset_in : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 clk_ref : IN STD_LOGIC;
		 tx_tkn : IN STD_LOGIC;
		 tx_scl : IN STD_LOGIC;
		 tx_sda : IN STD_LOGIC;
		 rx_flf_dv_out : IN STD_LOGIC;
		 rx_vlf_dv_out : IN STD_LOGIC;
		 vlf_e1_in : IN STD_LOGIC;
		 vlf_e2_in : IN STD_LOGIC;
		 vlf_e3_in : IN STD_LOGIC;
		 vlf_ta1_in : IN STD_LOGIC;
		 vlf_ta2_in : IN STD_LOGIC;
		 vlf_ta3_in : IN STD_LOGIC;
		 vlf_tb1_in : IN STD_LOGIC;
		 vlf_tb2_in : IN STD_LOGIC;
		 flf_p1_in : IN STD_LOGIC;
		 flf_p2_in : IN STD_LOGIC;
		 flf_e1_in : IN STD_LOGIC;
		 flf_e2_in : IN STD_LOGIC;
		 clk_en_in : IN STD_LOGIC;
		 reg_init : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 rx_flf_data_out : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 rx_vlf_data_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ta_delay : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 rx_tkn : OUT STD_LOGIC;
		 rx_scl : OUT STD_LOGIC;
		 rx_sda : OUT STD_LOGIC;
		 tx_flf_dv_in : OUT STD_LOGIC;
		 tx_vlf_dv_in : OUT STD_LOGIC;
		 vlf_e1_out : OUT STD_LOGIC;
		 vlf_e2_out : OUT STD_LOGIC;
		 vlf_e3_out : OUT STD_LOGIC;
		 vlf_ta1_out : OUT STD_LOGIC;
		 vlf_ta2_out : OUT STD_LOGIC;
		 vlf_ta3_out : OUT STD_LOGIC;
		 vlf_tb1_out : OUT STD_LOGIC;
		 vlf_tb2_out : OUT STD_LOGIC;
		 flf_p1_out : OUT STD_LOGIC;
		 flf_p2_out : OUT STD_LOGIC;
		 flf_e1_out : OUT STD_LOGIC;
		 flf_e2_out : OUT STD_LOGIC;
		 tx_flf_data_in : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 tx_vlf_data_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

-- COMPONENT rx_8x_rhseu
COMPONENT RX_8x_4b_6b_RHSEU 
GENERIC (FLF_param_b : INTEGER;
			N_CYC : INTEGER;
			N_CYC_b : INTEGER;
			N_FRM : INTEGER
			);
	PORT(DAT_in : IN STD_LOGIC;
		 FLF_on : IN STD_LOGIC;
		 Get_Data : IN STD_LOGIC;
		 clk_enable : IN STD_LOGIC;
		 clk_tx : IN STD_LOGIC;
		 rst_L : IN STD_LOGIC;
		 FD_FIFO_empty : IN STD_LOGIC;
		 FD_FIFO_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 FLF_param : IN STD_LOGIC_VECTOR(6 DOWNTO 0);
		 write_RX_BUF : OUT STD_LOGIC;
		 read_RX_BUF : OUT STD_LOGIC;
		 Data_Type : OUT STD_LOGIC;
		 Data_Valid : OUT STD_LOGIC;
		 Frame_Lost : OUT STD_LOGIC;
		 Label_On : OUT STD_LOGIC;
		 Last_Frame : OUT STD_LOGIC;
		 TRG_out : OUT STD_LOGIC;
		 clk_out : OUT STD_LOGIC;
		 write_FD_FIFO : OUT STD_LOGIC;
		 read_FD_FIFO : OUT STD_LOGIC;
		 sync : OUT STD_LOGIC;
		 resync : OUT STD_LOGIC;
		 seu_out : OUT STD_LOGIC;
		 THS_seu : OUT STD_LOGIC;
		 FD_SEU : OUT STD_LOGIC;
		 FD_DEU : OUT STD_LOGIC;
		 FD_FIFO_in : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 FLF_data_out : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 RX_BUF_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x22
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x22_cl_en
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 enable : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x14
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x14_cl_en
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 enable : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(8 DOWNTO 0)
	);
END COMPONENT;

--COMPONENT tx_rhseu
COMPONENT TX_8x_4b_6b_RHSEU 
GENERIC (FLF_param_b : INTEGER;
			N_CYC : INTEGER;
			N_CYC_b : INTEGER;
			N_FRM : INTEGER
			);
	PORT(Data_Type : IN STD_LOGIC;
		 Data_Valid : IN STD_LOGIC;
		 FLF_on : IN STD_LOGIC;
		 Label_On : IN STD_LOGIC;
		 TRG : IN STD_LOGIC;
		 TX_BUF_full : IN STD_LOGIC;
		 clk40 : IN STD_LOGIC;
		 clk_tx : IN STD_LOGIC;
		 rst_L : IN STD_LOGIC;
		 FDC_FIFO_empty : IN STD_LOGIC;
		 FDC_FIFO_full : IN STD_LOGIC;
		 FDC_FIFO_out : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 FLF_data_in : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 FLF_param : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 TX_BUF_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 read_TX_Buf : OUT STD_LOGIC;
		 read_FDC_FIFO : OUT STD_LOGIC;
		 write_FDC_FIFO : OUT STD_LOGIC;
		 DAT_out : OUT STD_LOGIC;
		 Get_Data : OUT STD_LOGIC;
		 seu_out : OUT STD_LOGIC;
		 FDC_FIFO_in : OUT STD_LOGIC_VECTOR(11 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x22_cl
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x18
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x18_cl
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(11 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	fifo_rx_ded_en :  STD_LOGIC;
SIGNAL	fifo_rx_sel :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	fifo_tx_ded_en :  STD_LOGIC;
SIGNAL	fifo_tx_sel :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	flf_data_in :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	flf_data_out :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	flf_data_valid_in :  STD_LOGIC;
SIGNAL	flf_data_valid_out :  STD_LOGIC;
SIGNAL	flf_rx_size :  STD_LOGIC_VECTOR(6 DOWNTO 0);
SIGNAL	flf_tx_size :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	if_reset_b :  STD_LOGIC;
SIGNAL	rx_8x_data_flf :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	rx_8x_dt :  STD_LOGIC;
SIGNAL	rx_8x_dv :  STD_LOGIC;
SIGNAL	rx_8x_dw_fifo_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_8x_dw_fifo_rd :  STD_LOGIC;
SIGNAL	rx_8x_dw_fifo_wr :  STD_LOGIC;
SIGNAL	rx_8x_fd_fifo_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	rx_8x_fd_fifo_rd :  STD_LOGIC;
SIGNAL	rx_8x_fd_fifo_wr :  STD_LOGIC;
SIGNAL	rx_8x_fl :  STD_LOGIC;
SIGNAL	rx_8x_lf :  STD_LOGIC;
SIGNAL	rx_8x_lo :  STD_LOGIC;
SIGNAL	rx_8x_trg :  STD_LOGIC;
SIGNAL	rx_dw_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	rx_dw_fifo_deu :  STD_LOGIC;
SIGNAL	rx_dw_fifo_empty :  STD_LOGIC;
SIGNAL	rx_dw_fifo_full :  STD_LOGIC;
SIGNAL	rx_dw_fifo_in :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	rx_dw_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_dw_fifo_seu :  STD_LOGIC;
SIGNAL	rx_dw_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_fd_deu :  STD_LOGIC;
SIGNAL	rx_fd_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	rx_fd_fifo_deu :  STD_LOGIC;
SIGNAL	rx_fd_fifo_empty :  STD_LOGIC;
SIGNAL	rx_fd_fifo_full :  STD_LOGIC;
SIGNAL	rx_fd_fifo_in :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	rx_fd_fifo_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	rx_fd_fifo_seu :  STD_LOGIC;
SIGNAL	rx_fd_seu :  STD_LOGIC;
SIGNAL	rx_fd_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_seu :  STD_LOGIC;
SIGNAL	rx_ths_seu :  STD_LOGIC;
SIGNAL	tx_8x_data_flf :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	tx_8x_dv :  STD_LOGIC;
SIGNAL	tx_8x_dw_fifo_rd :  STD_LOGIC;
SIGNAL	tx_8x_fd_fifo_in :  STD_LOGIC_VECTOR(11 DOWNTO 0);
SIGNAL	tx_8x_fd_fifo_rd :  STD_LOGIC;
SIGNAL	tx_8x_fd_fifo_wr :  STD_LOGIC;
SIGNAL	tx_8x_trg :  STD_LOGIC;
SIGNAL	tx_data :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_dw_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	tx_dw_fifo_deu :  STD_LOGIC;
SIGNAL	tx_dw_fifo_empty :  STD_LOGIC;
SIGNAL	tx_dw_fifo_full :  STD_LOGIC;
SIGNAL	tx_dw_fifo_in :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	tx_dw_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_dw_fifo_seu :  STD_LOGIC;
SIGNAL	tx_dw_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_fd_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	tx_fd_fifo_deu :  STD_LOGIC;
SIGNAL	tx_fd_fifo_empty :  STD_LOGIC;
SIGNAL	tx_fd_fifo_full :  STD_LOGIC;
SIGNAL	tx_fd_fifo_in :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	tx_fd_fifo_out :  STD_LOGIC_VECTOR(11 DOWNTO 0);
SIGNAL	tx_fd_fifo_seu :  STD_LOGIC;
SIGNAL	tx_fd_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_gd :  STD_LOGIC;
SIGNAL	tx_seu :  STD_LOGIC;
SIGNAL	vlf_data_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	vlf_data_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	vlf_data_valid_in :  STD_LOGIC;
SIGNAL	vlf_data_valid_out :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_113 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_114 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_115 :  STD_LOGIC_VECTOR(0 TO 15);
SIGNAL	SYNTHESIZED_WIRE_18 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_19 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_20 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_21 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_22 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_23 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_24 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_25 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_116 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_117 :  STD_LOGIC_VECTOR(0 TO 8);
SIGNAL	SYNTHESIZED_WIRE_45 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_46 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_47 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_48 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_49 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_50 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_51 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_52 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_118 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_57 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_119 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_120 :  STD_LOGIC_VECTOR(0 TO 15);
SIGNAL	SYNTHESIZED_WIRE_75 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_76 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_77 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_78 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_79 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_80 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_81 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_82 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_121 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_122 :  STD_LOGIC_VECTOR(0 TO 11);
SIGNAL	SYNTHESIZED_WIRE_102 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_103 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_104 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_105 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_106 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_107 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_108 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_109 :  STD_LOGIC_VECTOR(17 DOWNTO 0);


BEGIN 
SYNTHESIZED_WIRE_113 <= '1';
SYNTHESIZED_WIRE_114 <= '0';
SYNTHESIZED_WIRE_115 <= "0000000000000000";
SYNTHESIZED_WIRE_116 <= '0';
SYNTHESIZED_WIRE_117 <= "000000000";
SYNTHESIZED_WIRE_118 <= '0';
SYNTHESIZED_WIRE_57 <= '1';
SYNTHESIZED_WIRE_119 <= '0';
SYNTHESIZED_WIRE_120 <= "0000000000000000";
SYNTHESIZED_WIRE_121 <= '0';
SYNTHESIZED_WIRE_122 <= "000000000000";


b2v_inst1 : ff_emu_emu_core
PORT MAP(reset_in => reset,
		 clk => rx_clk,
		 clk_ref => clk_ref,
		 tx_tkn => tx_tkn,
		 tx_scl => tx_scl,
		 tx_sda => tx_sda,
		 rx_flf_dv_out => flf_data_valid_in,
		 rx_vlf_dv_out => vlf_data_valid_in,
		 vlf_e1_in => vlf_e1_in,
		 vlf_e2_in => vlf_e2_in,
		 vlf_e3_in => vlf_e3_in,
		 vlf_ta1_in => vlf_ta1_in,
		 vlf_ta2_in => vlf_ta2_in,
		 vlf_ta3_in => vlf_ta3_in,
		 vlf_tb1_in => vlf_tb1_in,
		 vlf_tb2_in => vlf_tb2_in,
		 flf_p1_in => flf_p1_in,
		 flf_p2_in => flf_p2_in,
		 flf_e1_in => flf_e1_in,
		 flf_e2_in => flf_e2_in,
		 clk_en_in => rx_clk_en,
		 reg_init => reg_init,
		 rx_flf_data_out => flf_data_in,
		 rx_vlf_data_out => vlf_data_in,
		 ta_delay => ta_delay,
		 tb_delay => tb_delay,
		 rx_tkn => rx_tkn,
		 rx_scl => rx_scl,
		 rx_sda => rx_sda,
		 tx_flf_dv_in => flf_data_valid_out,
		 tx_vlf_dv_in => vlf_data_valid_out,
		 vlf_e1_out => vlf_e1_out,
		 vlf_e2_out => vlf_e2_out,
		 vlf_e3_out => vlf_e3_out,
		 vlf_ta1_out => vlf_ta1_out,
		 vlf_ta2_out => vlf_ta2_out,
		 vlf_ta3_out => vlf_ta3_out,
		 vlf_tb1_out => vlf_tb1_out,
		 vlf_tb2_out => vlf_tb2_out,
		 flf_p1_out => flf_p1_out,
		 flf_p2_out => flf_p2_out,
		 flf_e1_out => flf_e1_out,
		 flf_e2_out => flf_e2_out,
		 tx_flf_data_in => flf_data_out,
		 tx_vlf_data_in => vlf_data_out);



vlf_data_valid_in <= rx_8x_dv;

vlf_dv <= rx_8x_dv; 

flf_data_valid_in <= rx_8x_trg;

flf_dv <= rx_8x_trg;







flf_data_in <= rx_8x_data_flf;










vlf_data_in <= rx_dw_fifo_out;






tx_8x_trg <= flf_data_valid_out;


tx_8x_dv <= vlf_data_valid_out;

 -- tx_8x_trg <= '0';


 -- tx_8x_dv <= '0';



tx_8x_data_flf <= flf_data_out;


tx_data <= vlf_data_out;



if_reset_b <= NOT(reset);








--b2v_RX_8x : rx_8x_rhseu
b2v_RX_8x : RX_8x_4b_6b_RHSEU
GENERIC MAP(FLF_param_b => 7,
			N_CYC => 8,
			N_CYC_b => 3,
			N_FRM => 6
			)
PORT MAP(DAT_in => rx_dat,
		 FLF_on => SYNTHESIZED_WIRE_113,
		 Get_Data => SYNTHESIZED_WIRE_113,
		 clk_enable => rx_clk_en,
		 clk_tx => rx_clk,
		 rst_L => if_reset_b,
		 FD_FIFO_empty => rx_fd_fifo_empty,
		 FD_FIFO_out => rx_fd_fifo_out(7 DOWNTO 0),
		 FLF_param => flf_rx_size,
		 write_RX_BUF => rx_8x_dw_fifo_wr,
		 read_RX_BUF => rx_8x_dw_fifo_rd,
		 Data_Valid => rx_8x_dv,
		 TRG_out => rx_8x_trg,
		 clk_out => rx_rec_clk,
		 write_FD_FIFO => rx_8x_fd_fifo_wr,
		 read_FD_FIFO => rx_8x_fd_fifo_rd,
		 sync => rx_sync,
		 resync => rx_resync,
		 FD_FIFO_in => rx_8x_fd_fifo_in(7 DOWNTO 0),
		 FLF_data_out => rx_8x_data_flf,
		 RX_BUF_in => rx_8x_dw_fifo_in);


b2v_RX_DW_FIFO_ARRAY : array_32x22
PORT MAP(CLK => rx_clk,
		 RST_L => if_reset_b,
		 EN => rx_dw_enable,
		 IN_W0 => rx_dw_fifo_in,
		 W_ADDR_11_8 => rx_dw_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => rx_dw_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => rx_dw_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => rx_dw_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => rx_dw_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => rx_dw_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => rx_dw_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => rx_dw_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_18,
		 OUTB_15_12 => SYNTHESIZED_WIRE_19,
		 OUTB_19_16 => SYNTHESIZED_WIRE_20,
		 OUTB_23_20 => SYNTHESIZED_WIRE_21,
		 OUTB_27_24 => SYNTHESIZED_WIRE_22,
		 OUTB_31_28 => SYNTHESIZED_WIRE_23,
		 OUTB_3_0 => SYNTHESIZED_WIRE_24,
		 OUTB_7_4 => SYNTHESIZED_WIRE_25);


b2v_RX_DW_FIFO_CL : new_fifo_32x22_cl_en
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 22,
			N_BIT_DEC => 16,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => rx_clk,
		 fifo_ded_en => fifo_rx_ded_en,
		 fifo_test_en => SYNTHESIZED_WIRE_114,
		 rst_l => if_reset_b,
		 test_read => SYNTHESIZED_WIRE_114,
		 test_write => SYNTHESIZED_WIRE_114,
		 ded_16x_read => SYNTHESIZED_WIRE_114,
		 ded_16x_write => SYNTHESIZED_WIRE_114,
		 ded_4x_read => SYNTHESIZED_WIRE_114,
		 ded_4x_write => SYNTHESIZED_WIRE_114,
		 ded_8x_read => SYNTHESIZED_WIRE_114,
		 ded_8x_write => SYNTHESIZED_WIRE_114,
		 seu_16x_read => SYNTHESIZED_WIRE_114,
		 seu_16x_write => SYNTHESIZED_WIRE_114,
		 seu_4x_read => SYNTHESIZED_WIRE_114,
		 seu_4x_write => SYNTHESIZED_WIRE_114,
		 seu_8x_read => rx_8x_dw_fifo_rd,
		 seu_8x_write => rx_8x_dw_fifo_wr,
		 enable => rx_clk_en,
		 ded_16x_word_in => SYNTHESIZED_WIRE_115,
		 ded_4x_word_in => SYNTHESIZED_WIRE_115,
		 ded_8x_word_in => SYNTHESIZED_WIRE_115,
		 fifo_sel => fifo_rx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_18,
		 OUTB_15_12 => SYNTHESIZED_WIRE_19,
		 OUTB_19_16 => SYNTHESIZED_WIRE_20,
		 OUTB_23_20 => SYNTHESIZED_WIRE_21,
		 OUTB_27_24 => SYNTHESIZED_WIRE_22,
		 OUTB_31_28 => SYNTHESIZED_WIRE_23,
		 OUTB_3_0 => SYNTHESIZED_WIRE_24,
		 OUTB_7_3 => SYNTHESIZED_WIRE_25,
		 seu_16x_word_in => SYNTHESIZED_WIRE_115,
		 seu_4x_word_in => SYNTHESIZED_WIRE_115,
		 seu_8x_word_in => rx_8x_dw_fifo_in,
		 test_word_in => SYNTHESIZED_WIRE_115,
		 en_int => rx_dw_enable,
		 word_addr => rx_dw_waddr,
		 word_in_int => rx_dw_fifo_in,
		 word_out => rx_dw_fifo_out);


b2v_RX_FD_FIFO_ARRAY : array_32x14
PORT MAP(CLK => rx_clk,
		 RST_L => if_reset_b,
		 EN => rx_fd_enable,
		 IN_W0 => rx_fd_fifo_in,
		 W_ADDR_11_8 => rx_fd_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => rx_fd_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => rx_fd_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => rx_fd_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => rx_fd_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => rx_fd_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => rx_fd_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => rx_fd_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_45,
		 OUTB_15_12 => SYNTHESIZED_WIRE_46,
		 OUTB_19_16 => SYNTHESIZED_WIRE_47,
		 OUTB_23_20 => SYNTHESIZED_WIRE_48,
		 OUTB_27_24 => SYNTHESIZED_WIRE_49,
		 OUTB_31_28 => SYNTHESIZED_WIRE_50,
		 OUTB_3_0 => SYNTHESIZED_WIRE_51,
		 OUTB_7_4 => SYNTHESIZED_WIRE_52);


b2v_RX_FD_FIFO_CL : new_fifo_32x14_cl_en
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 14,
			N_BIT_DEC => 9,
			N_BIT_PAR => 5,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => rx_clk,
		 fifo_ded_en => fifo_rx_ded_en,
		 fifo_test_en => SYNTHESIZED_WIRE_116,
		 rst_l => if_reset_b,
		 test_read => SYNTHESIZED_WIRE_116,
		 test_write => SYNTHESIZED_WIRE_116,
		 ded_16x_read => SYNTHESIZED_WIRE_116,
		 ded_16x_write => SYNTHESIZED_WIRE_116,
		 ded_4x_read => SYNTHESIZED_WIRE_116,
		 ded_4x_write => SYNTHESIZED_WIRE_116,
		 ded_8x_read => SYNTHESIZED_WIRE_116,
		 ded_8x_write => SYNTHESIZED_WIRE_116,
		 seu_16x_read => SYNTHESIZED_WIRE_116,
		 seu_16x_write => SYNTHESIZED_WIRE_116,
		 seu_4x_read => SYNTHESIZED_WIRE_116,
		 seu_4x_write => SYNTHESIZED_WIRE_116,
		 seu_8x_read => rx_8x_fd_fifo_rd,
		 seu_8x_write => rx_8x_fd_fifo_wr,
		 enable => rx_clk_en,
		 ded_16x_word_in => SYNTHESIZED_WIRE_117,
		 ded_4x_word_in => SYNTHESIZED_WIRE_117,
		 ded_8x_word_in => SYNTHESIZED_WIRE_117,
		 fifo_sel => fifo_rx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_45,
		 OUTB_15_12 => SYNTHESIZED_WIRE_46,
		 OUTB_19_16 => SYNTHESIZED_WIRE_47,
		 OUTB_23_20 => SYNTHESIZED_WIRE_48,
		 OUTB_27_24 => SYNTHESIZED_WIRE_49,
		 OUTB_31_28 => SYNTHESIZED_WIRE_50,
		 OUTB_3_0 => SYNTHESIZED_WIRE_51,
		 OUTB_7_3 => SYNTHESIZED_WIRE_52,
		 seu_16x_word_in => SYNTHESIZED_WIRE_117,
		 seu_4x_word_in => SYNTHESIZED_WIRE_117,
		 seu_8x_word_in => rx_8x_fd_fifo_in,
		 test_word_in => SYNTHESIZED_WIRE_117,
		 empty => rx_fd_fifo_empty,
		 en_int => rx_fd_enable,
		 word_addr => rx_fd_waddr,
		 word_in_int => rx_fd_fifo_in,
		 word_out => rx_fd_fifo_out);


-- b2v_TX_8x : tx_rhseu
b2v_TX_8x : TX_8x_4b_6b_RHSEU
GENERIC MAP(FLF_param_b => 4,
			N_CYC => 8,
			N_CYC_b => 3,
			N_FRM => 6
			)
PORT MAP(Data_Type => SYNTHESIZED_WIRE_118,
		 Data_Valid => tx_8x_dv,
		 FLF_on => SYNTHESIZED_WIRE_57,
		 Label_On => SYNTHESIZED_WIRE_118,
		 TRG => tx_8x_trg,
		 TX_BUF_full => tx_dw_fifo_full,
		 clk40 => clk_ref,
		 clk_tx => tx_clk,
		 rst_L => if_reset_b,
		 FDC_FIFO_empty => tx_fd_fifo_empty,
		 FDC_FIFO_full => tx_fd_fifo_full,
		 FDC_FIFO_out => tx_fd_fifo_out,
		 FLF_data_in => tx_8x_data_flf,
		 FLF_param => flf_tx_size,
		 TX_BUF_out => tx_dw_fifo_out,
		 read_TX_Buf => tx_8x_dw_fifo_rd,
		 read_FDC_FIFO => tx_8x_fd_fifo_rd,
		 write_FDC_FIFO => tx_8x_fd_fifo_wr,
		 DAT_out => tx_dat,
		 FDC_FIFO_in => tx_8x_fd_fifo_in);


b2v_TX_DW_FIFO_ARRAY : array_32x22
PORT MAP(CLK => clk_ref,
		 RST_L => if_reset_b,
		 EN => tx_dw_enable,
		 IN_W0 => tx_dw_fifo_in,
		 W_ADDR_11_8 => tx_dw_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => tx_dw_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => tx_dw_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => tx_dw_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => tx_dw_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => tx_dw_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => tx_dw_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => tx_dw_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_75,
		 OUTB_15_12 => SYNTHESIZED_WIRE_76,
		 OUTB_19_16 => SYNTHESIZED_WIRE_77,
		 OUTB_23_20 => SYNTHESIZED_WIRE_78,
		 OUTB_27_24 => SYNTHESIZED_WIRE_79,
		 OUTB_31_28 => SYNTHESIZED_WIRE_80,
		 OUTB_3_0 => SYNTHESIZED_WIRE_81,
		 OUTB_7_4 => SYNTHESIZED_WIRE_82);


b2v_TX_DW_FIFO_CL : new_fifo_32x22_cl
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 22,
			N_BIT_DEC => 16,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => clk_ref,
		 fifo_ded_en => fifo_tx_ded_en,
		 fifo_test_en => SYNTHESIZED_WIRE_119,
		 rst_l => if_reset_b,
		 test_read => SYNTHESIZED_WIRE_119,
		 test_write => SYNTHESIZED_WIRE_119,
		 ded_16x_read => SYNTHESIZED_WIRE_119,
		 ded_16x_write => SYNTHESIZED_WIRE_119,
		 ded_4x_read => SYNTHESIZED_WIRE_119,
		 ded_4x_write => SYNTHESIZED_WIRE_119,
		 ded_8x_read => SYNTHESIZED_WIRE_119,
		 ded_8x_write => SYNTHESIZED_WIRE_119,
		 seu_16x_read => SYNTHESIZED_WIRE_119,
		 seu_16x_write => SYNTHESIZED_WIRE_119,
		 seu_4x_read => SYNTHESIZED_WIRE_119,
		 seu_4x_write => SYNTHESIZED_WIRE_119,
		 seu_8x_read => tx_8x_dw_fifo_rd,
		 seu_8x_write => tx_8x_dv,
		 ded_16x_word_in => SYNTHESIZED_WIRE_120,
		 ded_4x_word_in => SYNTHESIZED_WIRE_120,
		 ded_8x_word_in => SYNTHESIZED_WIRE_120,
		 fifo_sel => fifo_tx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_75,
		 OUTB_15_12 => SYNTHESIZED_WIRE_76,
		 OUTB_19_16 => SYNTHESIZED_WIRE_77,
		 OUTB_23_20 => SYNTHESIZED_WIRE_78,
		 OUTB_27_24 => SYNTHESIZED_WIRE_79,
		 OUTB_31_28 => SYNTHESIZED_WIRE_80,
		 OUTB_3_0 => SYNTHESIZED_WIRE_81,
		 OUTB_7_3 => SYNTHESIZED_WIRE_82,
		 seu_16x_word_in => SYNTHESIZED_WIRE_120,
		 seu_4x_word_in => SYNTHESIZED_WIRE_120,
		 seu_8x_word_in => tx_data,
		 test_word_in => SYNTHESIZED_WIRE_120,
		 full => tx_dw_fifo_full,
		 en_int => tx_dw_enable,
		 word_addr => tx_dw_waddr,
		 word_in_int => tx_dw_fifo_in,
		 word_out => tx_dw_fifo_out);


b2v_TX_FD_FIFO_ARRAY : array_32x18
PORT MAP(CLK => clk_ref,
		 RST_L => if_reset_b,
		 EN => tx_fd_enable,
		 IN_W0 => tx_fd_fifo_in,
		 W_ADDR_11_8 => tx_fd_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => tx_fd_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => tx_fd_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => tx_fd_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => tx_fd_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => tx_fd_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => tx_fd_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => tx_fd_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_102,
		 OUTB_15_12 => SYNTHESIZED_WIRE_103,
		 OUTB_19_16 => SYNTHESIZED_WIRE_104,
		 OUTB_23_20 => SYNTHESIZED_WIRE_105,
		 OUTB_27_24 => SYNTHESIZED_WIRE_106,
		 OUTB_31_28 => SYNTHESIZED_WIRE_107,
		 OUTB_3_0 => SYNTHESIZED_WIRE_108,
		 OUTB_7_4 => SYNTHESIZED_WIRE_109);


b2v_TX_FD_FIFO_CL : new_fifo_32x18_cl
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 18,
			N_BIT_DEC => 12,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => clk_ref,
		 fifo_ded_en => fifo_tx_ded_en,
		 fifo_test_en => SYNTHESIZED_WIRE_121,
		 rst_l => if_reset_b,
		 test_read => SYNTHESIZED_WIRE_121,
		 test_write => SYNTHESIZED_WIRE_121,
		 ded_16x_read => SYNTHESIZED_WIRE_121,
		 ded_16x_write => SYNTHESIZED_WIRE_121,
		 ded_4x_read => SYNTHESIZED_WIRE_121,
		 ded_4x_write => SYNTHESIZED_WIRE_121,
		 ded_8x_read => SYNTHESIZED_WIRE_121,
		 ded_8x_write => SYNTHESIZED_WIRE_121,
		 seu_16x_read => SYNTHESIZED_WIRE_121,
		 seu_16x_write => SYNTHESIZED_WIRE_121,
		 seu_4x_read => SYNTHESIZED_WIRE_121,
		 seu_4x_write => SYNTHESIZED_WIRE_121,
		 seu_8x_read => tx_8x_fd_fifo_rd,
		 seu_8x_write => tx_8x_fd_fifo_wr,
		 ded_16x_word_in => SYNTHESIZED_WIRE_122,
		 ded_4x_word_in => SYNTHESIZED_WIRE_122,
		 ded_8x_word_in => SYNTHESIZED_WIRE_122,
		 fifo_sel => fifo_tx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_102,
		 OUTB_15_12 => SYNTHESIZED_WIRE_103,
		 OUTB_19_16 => SYNTHESIZED_WIRE_104,
		 OUTB_23_20 => SYNTHESIZED_WIRE_105,
		 OUTB_27_24 => SYNTHESIZED_WIRE_106,
		 OUTB_31_28 => SYNTHESIZED_WIRE_107,
		 OUTB_3_0 => SYNTHESIZED_WIRE_108,
		 OUTB_7_3 => SYNTHESIZED_WIRE_109,
		 seu_16x_word_in => SYNTHESIZED_WIRE_122,
		 seu_4x_word_in => SYNTHESIZED_WIRE_122,
		 seu_8x_word_in => tx_8x_fd_fifo_in,
		 test_word_in => SYNTHESIZED_WIRE_122,
		 empty => tx_fd_fifo_empty,
		 full => tx_fd_fifo_full,
		 en_int => tx_fd_enable,
		 word_addr => tx_fd_waddr,
		 word_in_int => tx_fd_fifo_in,
		 word_out => tx_fd_fifo_out);

-- old flf_rx_size = 3x8-4=20 = 001 0100
-- flf_rx_size(6) <= '0';
-- flf_rx_size(5) <= '0';
-- flf_rx_size(4) <= '1';
-- flf_rx_size(3) <= '0';
-- flf_rx_size(2) <= '1';
-- flf_rx_size(1) <= '0';
-- flf_rx_size(0) <= '0';

-- new flf_rx_size = 3x8-2=22 = 001 0110
flf_rx_size(6) <= '0';
flf_rx_size(5) <= '0';
flf_rx_size(4) <= '1';
flf_rx_size(3) <= '0';
flf_rx_size(2) <= '1';
flf_rx_size(1) <= '1';
flf_rx_size(0) <= '0';

fifo_rx_ded_en <= '0';
fifo_rx_sel(0) <= '0';
fifo_rx_sel(1) <= '1';
fifo_tx_ded_en <= '0';
fifo_tx_sel(0) <= '0';
fifo_tx_sel(1) <= '1';
flf_tx_size(3) <= '0';
flf_tx_size(2) <= '0';
flf_tx_size(0) <= '0';
flf_tx_size(1) <= '1';
rx_8x_fd_fifo_in(8) <= '0';
END bdf_type;