-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:43:54 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY error_stretch IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		error_in :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		error_out :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END error_stretch;

ARCHITECTURE bdf_type OF error_stretch IS 

SIGNAL	error_out_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_21 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_22 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_23 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_24 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_7 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_25 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_26 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_10 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_12 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_14 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_16 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_18 :  STD_LOGIC;


BEGIN 
SYNTHESIZED_WIRE_21 <= '1';
SYNTHESIZED_WIRE_24 <= '1';
SYNTHESIZED_WIRE_25 <= '1';



PROCESS(error_in(2),SYNTHESIZED_WIRE_0,SYNTHESIZED_WIRE_21)
BEGIN
IF (SYNTHESIZED_WIRE_0 <= '0') THEN
	SYNTHESIZED_WIRE_22 <= '0';
ELSIF (SYNTHESIZED_WIRE_21 = '0') THEN
	SYNTHESIZED_WIRE_22 <= '1';
ELSIF (RISING_EDGE(error_in(2))) THEN
	SYNTHESIZED_WIRE_22 <= SYNTHESIZED_WIRE_21;
END IF;
END PROCESS;


SYNTHESIZED_WIRE_0 <= NOT(error_out_ALTERA_SYNTHESIZED(2) OR SYNTHESIZED_WIRE_22);


SYNTHESIZED_WIRE_5 <= SYNTHESIZED_WIRE_3 AND SYNTHESIZED_WIRE_23;


PROCESS(clk,SYNTHESIZED_WIRE_24)
BEGIN
IF (SYNTHESIZED_WIRE_24 <= '0') THEN
	error_out_ALTERA_SYNTHESIZED(1) <= '0';
ELSIF (SYNTHESIZED_WIRE_24 = '0') THEN
	error_out_ALTERA_SYNTHESIZED(1) <= '1';
ELSIF (RISING_EDGE(clk)) THEN
	error_out_ALTERA_SYNTHESIZED(1) <= SYNTHESIZED_WIRE_5;
END IF;
END PROCESS;


PROCESS(error_in(0),SYNTHESIZED_WIRE_7,SYNTHESIZED_WIRE_25)
BEGIN
IF (SYNTHESIZED_WIRE_7 <= '0') THEN
	SYNTHESIZED_WIRE_26 <= '0';
ELSIF (SYNTHESIZED_WIRE_25 = '0') THEN
	SYNTHESIZED_WIRE_26 <= '1';
ELSIF (RISING_EDGE(error_in(0))) THEN
	SYNTHESIZED_WIRE_26 <= SYNTHESIZED_WIRE_25;
END IF;
END PROCESS;



SYNTHESIZED_WIRE_7 <= NOT(error_out_ALTERA_SYNTHESIZED(0) OR SYNTHESIZED_WIRE_26);


SYNTHESIZED_WIRE_10 <= NOT(reset(0));



SYNTHESIZED_WIRE_12 <= SYNTHESIZED_WIRE_10 AND SYNTHESIZED_WIRE_26;


PROCESS(clk,SYNTHESIZED_WIRE_25)
BEGIN
IF (SYNTHESIZED_WIRE_25 <= '0') THEN
	error_out_ALTERA_SYNTHESIZED(0) <= '0';
ELSIF (SYNTHESIZED_WIRE_25 = '0') THEN
	error_out_ALTERA_SYNTHESIZED(0) <= '1';
ELSIF (RISING_EDGE(clk)) THEN
	error_out_ALTERA_SYNTHESIZED(0) <= SYNTHESIZED_WIRE_12;
END IF;
END PROCESS;


SYNTHESIZED_WIRE_14 <= NOT(reset(2));



SYNTHESIZED_WIRE_16 <= SYNTHESIZED_WIRE_14 AND SYNTHESIZED_WIRE_22;


PROCESS(clk,SYNTHESIZED_WIRE_21)
BEGIN
IF (SYNTHESIZED_WIRE_21 <= '0') THEN
	error_out_ALTERA_SYNTHESIZED(2) <= '0';
ELSIF (SYNTHESIZED_WIRE_21 = '0') THEN
	error_out_ALTERA_SYNTHESIZED(2) <= '1';
ELSIF (RISING_EDGE(clk)) THEN
	error_out_ALTERA_SYNTHESIZED(2) <= SYNTHESIZED_WIRE_16;
END IF;
END PROCESS;


SYNTHESIZED_WIRE_18 <= NOT(error_out_ALTERA_SYNTHESIZED(1) OR SYNTHESIZED_WIRE_23);


PROCESS(error_in(1),SYNTHESIZED_WIRE_18,SYNTHESIZED_WIRE_24)
BEGIN
IF (SYNTHESIZED_WIRE_18 <= '0') THEN
	SYNTHESIZED_WIRE_23 <= '0';
ELSIF (SYNTHESIZED_WIRE_24 = '0') THEN
	SYNTHESIZED_WIRE_23 <= '1';
ELSIF (RISING_EDGE(error_in(1))) THEN
	SYNTHESIZED_WIRE_23 <= SYNTHESIZED_WIRE_24;
END IF;
END PROCESS;


SYNTHESIZED_WIRE_3 <= NOT(reset(1));




error_out <= error_out_ALTERA_SYNTHESIZED;

END bdf_type;