-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:05:17 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_error_cnt_en_gen IS 
	PORT
	(
		ec_test :  IN  STD_LOGIC;
		error :  IN  STD_LOGIC;
		ec_test_en :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ec_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END ff_emu_error_cnt_en_gen;

ARCHITECTURE bdf_type OF ff_emu_error_cnt_en_gen IS 

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ec_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_EC_EG_M2_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ec_test_en(0),
		 data0(0) => error,
		 data1(0) => ec_test,
		 result(0) => ec_en_ALTERA_SYNTHESIZED(0));


b2v_EC_EG_M2_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ec_test_en(1),
		 data0(0) => error,
		 data1(0) => ec_test,
		 result(0) => ec_en_ALTERA_SYNTHESIZED(1));


b2v_EC_EG_M2_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ec_test_en(2),
		 data0(0) => error,
		 data1(0) => ec_test,
		 result(0) => ec_en_ALTERA_SYNTHESIZED(2));

ec_en <= ec_en_ALTERA_SYNTHESIZED;

END bdf_type;