-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 22:02:15 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_i2c_slave IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		sdain :  IN  STD_LOGIC;
		ch_addr :  IN  STD_LOGIC;
		scl :  IN  STD_LOGIC;
		i2c_reg_10_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_10_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_10_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_11_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_11_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_11_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_12_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_12_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_12_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_13_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_13_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_13_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_14_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_14_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_14_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_15_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_15_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_15_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_8_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_8_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_8_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_9_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_9_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_9_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sdaouten :  OUT  STD_LOGIC;
		sdaout :  OUT  STD_LOGIC;
		i2c_addr :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_data_in :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_0_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_0_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_0_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_1_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_1_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_1_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_2_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_2_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_2_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_3_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_3_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_3_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_4_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_4_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_4_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_5_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_5_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_5_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_6_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_6_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_6_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_7_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_7_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_reg_7_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2c_wr_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END ff_emu_i2c_slave;

ARCHITECTURE bdf_type OF ff_emu_i2c_slave IS 

COMPONENT decode_8
	PORT(enable : IN STD_LOGIC;
		 data : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 eq0 : OUT STD_LOGIC;
		 eq1 : OUT STD_LOGIC;
		 eq2 : OUT STD_LOGIC;
		 eq3 : OUT STD_LOGIC;
		 eq4 : OUT STD_LOGIC;
		 eq5 : OUT STD_LOGIC;
		 eq6 : OUT STD_LOGIC;
		 eq7 : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT ff_emu_i2c_slave_core
	PORT(sdain : IN STD_LOGIC;
		 scl : IN STD_LOGIC;
		 ch_addr : IN STD_LOGIC;
		 dout_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 dout_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 dout_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sdaouten : OUT STD_LOGIC;
		 sdaout : OUT STD_LOGIC;
		 addr_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 addr_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 addr_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 din_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 din_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 din_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 wr_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux_16xn
GENERIC (n : INTEGER
			);
	PORT(data00 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data01 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data02 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data03 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data04 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data05 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data06 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data07 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data08 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data09 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data10 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data11 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data12 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data13 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data14 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data15 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 sel : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	i2c_addr_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_addr_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_addr_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_din_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_din_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_din_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_dout_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_dout_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_dout_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_0_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_0_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_0_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_0_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_10_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_10_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_10_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_11_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_11_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_11_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_12_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_12_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_12_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_13_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_13_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_13_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_14_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_14_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_14_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_15_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_15_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_15_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_1_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_1_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_1_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_1_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_2_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_2_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_2_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_2_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_3_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_3_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_3_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_3_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_4_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_4_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_4_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_4_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_5_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_5_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_5_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_5_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_6_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_6_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_6_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_6_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_7_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_7_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_7_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_7_wr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_reg_8_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_8_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_8_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_9_data_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_9_data_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_reg_9_data_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	i2c_wr_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_6 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_7 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_8 :  STD_LOGIC_VECTOR(0 TO 2);


BEGIN 
SYNTHESIZED_WIRE_0 <= "111";
SYNTHESIZED_WIRE_1 <= "111";
SYNTHESIZED_WIRE_2 <= "111";
SYNTHESIZED_WIRE_3 <= "111";
SYNTHESIZED_WIRE_4 <= "111";
SYNTHESIZED_WIRE_5 <= "111";
SYNTHESIZED_WIRE_6 <= "111";
SYNTHESIZED_WIRE_7 <= "111";
SYNTHESIZED_WIRE_8 <= "111";



b2v_DEC_A : decode_8
PORT MAP(enable => i2c_wr_en_ALTERA_SYNTHESIZED(0),
		 data => i2c_addr_a(3 DOWNTO 1),
		 eq0 => i2c_reg_0_wr_en(0),
		 eq1 => i2c_reg_1_wr_en(0),
		 eq2 => i2c_reg_2_wr_en(0),
		 eq3 => i2c_reg_3_wr_en(0),
		 eq4 => i2c_reg_4_wr_en(0),
		 eq5 => i2c_reg_5_wr_en(0),
		 eq6 => i2c_reg_6_wr_en(0),
		 eq7 => i2c_reg_7_wr_en(0));


b2v_DEC_B : decode_8
PORT MAP(enable => i2c_wr_en_ALTERA_SYNTHESIZED(1),
		 data => i2c_addr_b(3 DOWNTO 1),
		 eq0 => i2c_reg_0_wr_en(1),
		 eq1 => i2c_reg_1_wr_en(1),
		 eq2 => i2c_reg_2_wr_en(1),
		 eq3 => i2c_reg_3_wr_en(1),
		 eq4 => i2c_reg_4_wr_en(1),
		 eq5 => i2c_reg_5_wr_en(1),
		 eq6 => i2c_reg_6_wr_en(1),
		 eq7 => i2c_reg_7_wr_en(1));


b2v_DEC_C : decode_8
PORT MAP(enable => i2c_wr_en_ALTERA_SYNTHESIZED(2),
		 data => i2c_addr_c(3 DOWNTO 1),
		 eq0 => i2c_reg_0_wr_en(2),
		 eq1 => i2c_reg_1_wr_en(2),
		 eq2 => i2c_reg_2_wr_en(2),
		 eq3 => i2c_reg_3_wr_en(2),
		 eq4 => i2c_reg_4_wr_en(2),
		 eq5 => i2c_reg_5_wr_en(2),
		 eq6 => i2c_reg_6_wr_en(2),
		 eq7 => i2c_reg_7_wr_en(2));


b2v_I2C_SLAVE_CORE : ff_emu_i2c_slave_core
PORT MAP(sdain => sdain,
		 scl => scl,
		 ch_addr => ch_addr,
		 dout_a => i2c_dout_a,
		 dout_b => i2c_dout_b,
		 dout_c => i2c_dout_c,
		 enable => SYNTHESIZED_WIRE_0,
		 reset => i2c_reset,
		 sdaouten => sdaouten,
		 sdaout => sdaout,
		 addr_a => i2c_addr_a,
		 addr_b => i2c_addr_b,
		 addr_c => i2c_addr_c,
		 din_a => i2c_din_a,
		 din_b => i2c_din_b,
		 din_c => i2c_din_c,
		 wr_en => i2c_wr_en_ALTERA_SYNTHESIZED);


i2c_data_in <= i2c_din_a;


i2c_addr <= i2c_addr_a;











b2v_MUX_A : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => i2c_reg_0_data_a,
		 data01 => i2c_reg_1_data_a,
		 data02 => i2c_reg_2_data_a,
		 data03 => i2c_reg_3_data_a,
		 data04 => i2c_reg_4_data_a,
		 data05 => i2c_reg_5_data_a,
		 data06 => i2c_reg_6_data_a,
		 data07 => i2c_reg_7_data_a,
		 data08 => i2c_reg_8_data_a,
		 data09 => i2c_reg_9_data_a,
		 data10 => i2c_reg_10_data_a,
		 data11 => i2c_reg_11_data_a,
		 data12 => i2c_reg_12_data_a,
		 data13 => i2c_reg_13_data_a,
		 data14 => i2c_reg_14_data_a,
		 data15 => i2c_reg_15_data_a,
		 sel => i2c_addr_a(4 DOWNTO 1),
		 result => i2c_dout_a);


b2v_MUX_A11 : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => i2c_reg_0_data_b,
		 data01 => i2c_reg_1_data_b,
		 data02 => i2c_reg_2_data_b,
		 data03 => i2c_reg_3_data_b,
		 data04 => i2c_reg_4_data_b,
		 data05 => i2c_reg_5_data_b,
		 data06 => i2c_reg_6_data_b,
		 data07 => i2c_reg_7_data_b,
		 data08 => i2c_reg_8_data_b,
		 data09 => i2c_reg_9_data_b,
		 data10 => i2c_reg_10_data_b,
		 data11 => i2c_reg_11_data_b,
		 data12 => i2c_reg_12_data_b,
		 data13 => i2c_reg_13_data_b,
		 data14 => i2c_reg_14_data_b,
		 data15 => i2c_reg_15_data_b,
		 sel => i2c_addr_b(4 DOWNTO 1),
		 result => i2c_dout_b);


b2v_MUX_A13 : mux_16xn
GENERIC MAP(n => 8
			)
PORT MAP(data00 => i2c_reg_0_data_c,
		 data01 => i2c_reg_1_data_c,
		 data02 => i2c_reg_2_data_c,
		 data03 => i2c_reg_3_data_c,
		 data04 => i2c_reg_4_data_c,
		 data05 => i2c_reg_5_data_c,
		 data06 => i2c_reg_6_data_c,
		 data07 => i2c_reg_7_data_c,
		 data08 => i2c_reg_8_data_c,
		 data09 => i2c_reg_9_data_c,
		 data10 => i2c_reg_10_data_c,
		 data11 => i2c_reg_11_data_c,
		 data12 => i2c_reg_12_data_c,
		 data13 => i2c_reg_13_data_c,
		 data14 => i2c_reg_14_data_c,
		 data15 => i2c_reg_15_data_c,
		 sel => i2c_addr_c(4 DOWNTO 1),
		 result => i2c_dout_c);


b2v_R0 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_0_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_0_data_a,
		 data_b_out => i2c_reg_0_data_b,
		 data_c_out => i2c_reg_0_data_c);


b2v_R1 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_1_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_1_data_a,
		 data_b_out => i2c_reg_1_data_b,
		 data_c_out => i2c_reg_1_data_c);


b2v_R2 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_2_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_2_data_a,
		 data_b_out => i2c_reg_2_data_b,
		 data_c_out => i2c_reg_2_data_c);


b2v_R3 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_3_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_3_data_a,
		 data_b_out => i2c_reg_3_data_b,
		 data_c_out => i2c_reg_3_data_c);


b2v_R4 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_4_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_4_data_a,
		 data_b_out => i2c_reg_4_data_b,
		 data_c_out => i2c_reg_4_data_c);


b2v_R5 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_5_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_5_data_a,
		 data_b_out => i2c_reg_5_data_b,
		 data_c_out => i2c_reg_5_data_c);


b2v_R6 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_6_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_6_data_a,
		 data_b_out => i2c_reg_6_data_b,
		 data_c_out => i2c_reg_6_data_c);


b2v_R7 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => scl,
		 data_a_in => i2c_din_a,
		 data_b_in => i2c_din_b,
		 data_c_in => i2c_din_c,
		 enable => i2c_reg_7_wr_en,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_7_data_a,
		 data_b_out => i2c_reg_7_data_b,
		 data_c_out => i2c_reg_7_data_c);


b2v_SR0 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_0_data_a,
		 data_b_in => i2c_reg_0_data_b,
		 data_c_in => i2c_reg_0_data_c,
		 enable => SYNTHESIZED_WIRE_1,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_0_a,
		 data_b_out => i2c_reg_0_b,
		 data_c_out => i2c_reg_0_c);


b2v_SR1 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_1_data_a,
		 data_b_in => i2c_reg_1_data_b,
		 data_c_in => i2c_reg_1_data_c,
		 enable => SYNTHESIZED_WIRE_2,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_1_a,
		 data_b_out => i2c_reg_1_b,
		 data_c_out => i2c_reg_1_c);


b2v_SR2 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_2_data_a,
		 data_b_in => i2c_reg_2_data_b,
		 data_c_in => i2c_reg_2_data_c,
		 enable => SYNTHESIZED_WIRE_3,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_2_a,
		 data_b_out => i2c_reg_2_b,
		 data_c_out => i2c_reg_2_c);


b2v_SR3 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_3_data_a,
		 data_b_in => i2c_reg_3_data_b,
		 data_c_in => i2c_reg_3_data_c,
		 enable => SYNTHESIZED_WIRE_4,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_3_a,
		 data_b_out => i2c_reg_3_b,
		 data_c_out => i2c_reg_3_c);


b2v_SR4 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_4_data_a,
		 data_b_in => i2c_reg_4_data_b,
		 data_c_in => i2c_reg_4_data_c,
		 enable => SYNTHESIZED_WIRE_5,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_4_a,
		 data_b_out => i2c_reg_4_b,
		 data_c_out => i2c_reg_4_c);


b2v_SR5 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_5_data_a,
		 data_b_in => i2c_reg_5_data_b,
		 data_c_in => i2c_reg_5_data_c,
		 enable => SYNTHESIZED_WIRE_6,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_5_a,
		 data_b_out => i2c_reg_5_b,
		 data_c_out => i2c_reg_5_c);


b2v_SR6 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_6_data_a,
		 data_b_in => i2c_reg_6_data_b,
		 data_c_in => i2c_reg_6_data_c,
		 enable => SYNTHESIZED_WIRE_7,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_6_a,
		 data_b_out => i2c_reg_6_b,
		 data_c_out => i2c_reg_6_c);


b2v_SR7 : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_reg_7_data_a,
		 data_b_in => i2c_reg_7_data_b,
		 data_c_in => i2c_reg_7_data_c,
		 enable => SYNTHESIZED_WIRE_8,
		 reset => i2c_reset,
		 data_a_out => i2c_reg_7_a,
		 data_b_out => i2c_reg_7_b,
		 data_c_out => i2c_reg_7_c);

i2c_reg_8_data_a <= i2c_reg_8_a;
i2c_reg_9_data_a <= i2c_reg_9_a;
i2c_reg_10_data_a <= i2c_reg_10_a;
i2c_reg_11_data_a <= i2c_reg_11_a;
i2c_reg_12_data_a <= i2c_reg_12_a;
i2c_reg_13_data_a <= i2c_reg_13_a;
i2c_reg_14_data_a <= i2c_reg_14_a;
i2c_reg_15_data_a <= i2c_reg_15_a;
i2c_reg_8_data_b <= i2c_reg_8_b;
i2c_reg_9_data_b <= i2c_reg_9_b;
i2c_reg_10_data_b <= i2c_reg_10_b;
i2c_reg_11_data_b <= i2c_reg_11_b;
i2c_reg_12_data_b <= i2c_reg_12_b;
i2c_reg_13_data_b <= i2c_reg_13_b;
i2c_reg_14_data_b <= i2c_reg_14_b;
i2c_reg_15_data_b <= i2c_reg_15_b;
i2c_reg_8_data_c <= i2c_reg_8_c;
i2c_reg_9_data_c <= i2c_reg_9_c;
i2c_reg_10_data_c <= i2c_reg_10_c;
i2c_reg_11_data_c <= i2c_reg_11_c;
i2c_reg_12_data_c <= i2c_reg_12_c;
i2c_reg_13_data_c <= i2c_reg_13_c;
i2c_reg_14_data_c <= i2c_reg_14_c;
i2c_reg_15_data_c <= i2c_reg_15_c;
i2c_wr_en <= i2c_wr_en_ALTERA_SYNTHESIZED;

END bdf_type;