-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 22:24:46 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY hamming_dec IS 
	PORT
	(
		ham_dec_in :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		ham_dec_out :  OUT  STD_LOGIC_VECTOR(10 DOWNTO 0)
	);
END hamming_dec;

ARCHITECTURE bdf_type OF hamming_dec IS 

COMPONENT hamming_16_11_decoder
	PORT(word_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 s_err : OUT STD_LOGIC;
		 d_err : OUT STD_LOGIC;
		 word_dec : OUT STD_LOGIC_VECTOR(10 DOWNTO 0)
	);
END COMPONENT;



BEGIN 



b2v_inst : hamming_16_11_decoder
PORT MAP(word_in => ham_dec_in,
		 word_dec => ham_dec_out);


END bdf_type;