-- mux2_Nbit
--
-- 2-input, N-bit multiplexer

library IEEE;
use IEEE.std_logic_1164.all;


entity mux2_Nbit is	
	generic (N : integer);
	port (
		x0 : in std_logic_vector (N-1 downto 0);
		x1 : in std_logic_vector (N-1 downto 0);
		sel : in std_logic;
		z : out std_logic_vector (N-1 downto 0)
	);
end entity;

architecture mux2_Nbit_arch of mux2_Nbit is
begin

	process (sel, x0, x1)
	begin
		if (sel = '0') then
			 z <= x0;
		else
			 z <= x1;
		end if;
	end process;

end architecture;
