-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Feb 04 01:20:51 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_core IS 
	PORT
	(
		tx_seu :  IN  STD_LOGIC;
		tx_fs_seu :  IN  STD_LOGIC;
		tx_dwf_seu :  IN  STD_LOGIC;
		tx_dwf_deu :  IN  STD_LOGIC;
		tx_fdf_seu :  IN  STD_LOGIC;
		tx_fdf_deu :  IN  STD_LOGIC;
		rx_seu :  IN  STD_LOGIC;
		rx_fs_seu :  IN  STD_LOGIC;
		rx_dwf_seu :  IN  STD_LOGIC;
		rx_dwf_deu :  IN  STD_LOGIC;
		rx_fdf_seu :  IN  STD_LOGIC;
		rx_fdf_deu :  IN  STD_LOGIC;
		rx_ths_seu :  IN  STD_LOGIC;
		rx_fd_seu :  IN  STD_LOGIC;
		rx_fd_deu :  IN  STD_LOGIC;
		rx_sl :  IN  STD_LOGIC;
		vlf_e1_in :  IN  STD_LOGIC;
		vlf_e2_in :  IN  STD_LOGIC;
		vlf_e3_in :  IN  STD_LOGIC;
		vlf_ta1_in :  IN  STD_LOGIC;
		vlf_ta2_in :  IN  STD_LOGIC;
		vlf_ta3_in :  IN  STD_LOGIC;
		vlf_tb1_in :  IN  STD_LOGIC;
		vlf_tb2_in :  IN  STD_LOGIC;
		flf_p1_in :  IN  STD_LOGIC;
		flf_p2_in :  IN  STD_LOGIC;
		flf_e1_in :  IN  STD_LOGIC;
		flf_e2_in :  IN  STD_LOGIC;
		rx_flf_dv_out :  IN  STD_LOGIC;
		rx_vlf_dv_out :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		clk_ref :  IN  STD_LOGIC;
		clk_en :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		mode_sel :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rx_dw_fifo_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		rx_fd_fifo_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		rx_flf_data_out :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		rx_vlf_data_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		tx_dw_fifo_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		tx_fd_fifo_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		flf_p1_out :  OUT  STD_LOGIC;
		flf_p2_out :  OUT  STD_LOGIC;
		flf_e1_out :  OUT  STD_LOGIC;
		flf_e2_out :  OUT  STD_LOGIC;
		vlf_e1_out :  OUT  STD_LOGIC;
		vlf_e3_out :  OUT  STD_LOGIC;
		vlf_e2_out :  OUT  STD_LOGIC;
		vlf_ta1_out :  OUT  STD_LOGIC;
		vlf_ta2_out :  OUT  STD_LOGIC;
		vlf_ta3_out :  OUT  STD_LOGIC;
		vlf_tb1_out :  OUT  STD_LOGIC;
		vlf_tb2_out :  OUT  STD_LOGIC;
		tx_flf_dv_in :  OUT  STD_LOGIC;
		tx_vlf_dv_in :  OUT  STD_LOGIC;
		tx_dw_fifo_test_en :  OUT  STD_LOGIC;
		tx_dw_fifo_test_wr :  OUT  STD_LOGIC;
		tx_dw_fifo_test_rd :  OUT  STD_LOGIC;
		tx_fd_fifo_test_en :  OUT  STD_LOGIC;
		tx_fd_fifo_test_wr :  OUT  STD_LOGIC;
		tx_fd_fifo_test_rd :  OUT  STD_LOGIC;
		rx_dw_fifo_test_en :  OUT  STD_LOGIC;
		rx_dw_fifo_test_wr :  OUT  STD_LOGIC;
		rx_dw_fifo_test_rd :  OUT  STD_LOGIC;
		rx_fd_fifo_test_en :  OUT  STD_LOGIC;
		rx_fd_fifo_test_wr :  OUT  STD_LOGIC;
		rx_fd_fifo_test_rd :  OUT  STD_LOGIC;
		token_out :  OUT  STD_LOGIC;
		sdaouten :  OUT  STD_LOGIC;
		scl :  OUT  STD_LOGIC;
		sdain :  OUT  STD_LOGIC;
		sdaout :  OUT  STD_LOGIC;
		rx_dw_fifo_test_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
		rx_fd_fifo_test_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
		tx_dw_fifo_test_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
		tx_fd_fifo_test_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
		tx_flf_data_in :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0);
		tx_vlf_data_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END ff_emu_core;

ARCHITECTURE bdf_type OF ff_emu_core IS 

COMPONENT ff_emu_error_cnt_mod
	PORT(ec_test : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 tx_dwf_seu : IN STD_LOGIC;
		 rx_dwf_seu : IN STD_LOGIC;
		 tx_dwf_deu : IN STD_LOGIC;
		 rx_dwf_deu : IN STD_LOGIC;
		 tx_fdf_seu : IN STD_LOGIC;
		 rx_fdf_seu : IN STD_LOGIC;
		 tx_fdf_deu : IN STD_LOGIC;
		 rx_fdf_deu : IN STD_LOGIC;
		 tx_seu : IN STD_LOGIC;
		 tx_fs_seu : IN STD_LOGIC;
		 rx_seu : IN STD_LOGIC;
		 rx_fs_seu : IN STD_LOGIC;
		 rx_sl : IN STD_LOGIC;
		 rx_ths_seu : IN STD_LOGIC;
		 rx_fd_seu : IN STD_LOGIC;
		 rx_fd_deu : IN STD_LOGIC;
		 ec_enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ec_reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ec_sel_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_sel_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_sel_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_test_en : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ec_out_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_out_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_out_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_test_out_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_test_out_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ec_test_out_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 rx_dwf_deu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_dwf_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fd_deu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fd_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fdf_deu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fdf_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fs_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_sl_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_ths_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_dwf_deu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_dwf_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fdf_deu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fdf_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fs_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_seu_ef : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_dec_rh
	PORT(clk : IN STD_LOGIC;
		 flf_data_valid : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 flf_data : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 p1_out : OUT STD_LOGIC;
		 e1_out : OUT STD_LOGIC;
		 p2_out : OUT STD_LOGIC;
		 e2_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT flf_enc_rh
	PORT(p1_in : IN STD_LOGIC;
		 p2_in : IN STD_LOGIC;
		 e1_in : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 e2_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 flf_data_valid : OUT STD_LOGIC;
		 flf_data : OUT STD_LOGIC_VECTOR(5 DOWNTO 0)
	);
END COMPONENT;

COMPONENT ff_emu_i2c_slave
	PORT(clk : IN STD_LOGIC;
		 sdain : IN STD_LOGIC;
		 scl : IN STD_LOGIC;
		 ch_addr : IN STD_LOGIC;
		 i2c_reg_10_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_10_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_10_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_11_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_11_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_11_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_12_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_12_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_12_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_13_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_13_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_13_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_14_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_14_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_14_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_15_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_15_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_15_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_8_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_8_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_8_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_9_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_9_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_9_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sdaouten : OUT STD_LOGIC;
		 sdaout : OUT STD_LOGIC;
		 i2c_reg_0_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_0_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_0_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_1_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_1_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_1_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_2_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_2_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_2_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_3_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_3_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_3_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_4_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_4_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_4_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_5_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_5_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_5_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_6_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_6_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_6_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_7_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_7_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 i2c_reg_7_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT net_assignment_mod
	PORT(rx_dwf_deu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_dwf_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fd_deu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fd_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fdf_deu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fdf_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_fs_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_sl_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_ths_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_dwf_deu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_dwf_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fdf_deu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fdf_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_fs_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 tx_seu_ef : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ef_reg_a : OUT STD_LOGIC_VECTOR(23 DOWNTO 0);
		 ef_reg_b : OUT STD_LOGIC_VECTOR(23 DOWNTO 0);
		 ef_reg_c : OUT STD_LOGIC_VECTOR(23 DOWNTO 0)
	);
END COMPONENT;

COMPONENT rx_sl_sync_reg
	PORT(rx_sl : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sync_rx_sl : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT test_module
	PORT(clk : IN STD_LOGIC;
		 ee_flf_dv_out : IN STD_LOGIC;
		 ee_vlf_dv_out : IN STD_LOGIC;
		 rx_flf_dv_out : IN STD_LOGIC;
		 rx_vlf_dv_out : IN STD_LOGIC;
		 sdaout_test : IN STD_LOGIC;
		 ec_test_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ed_flf_data_out : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 ed_vlf_data_out : IN STD_LOGIC_VECTOR(10 DOWNTO 0);
		 ee_flf_data_out : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 ee_vlf_data_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 flf_data_in : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 mode_sel : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_dw_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_fd_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_flf_data_out : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 rx_vlf_data_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_dw_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_fd_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 vlf_data_in : IN STD_LOGIC_VECTOR(10 DOWNTO 0);
		 tx_flf_dv_in : OUT STD_LOGIC;
		 tx_vlf_dv_in : OUT STD_LOGIC;
		 ed_flf_dv_in : OUT STD_LOGIC;
		 ed_vlf_dv_in : OUT STD_LOGIC;
		 tx_dw_fifo_we : OUT STD_LOGIC;
		 tx_dw_fifo_re : OUT STD_LOGIC;
		 tx_fd_fifo_we : OUT STD_LOGIC;
		 tx_fd_fifo_re : OUT STD_LOGIC;
		 rx_dw_fifo_we : OUT STD_LOGIC;
		 rx_dw_fifo_re : OUT STD_LOGIC;
		 rx_fd_fifo_we : OUT STD_LOGIC;
		 rx_fd_fifo_re : OUT STD_LOGIC;
		 rx_fd_fifo_te : OUT STD_LOGIC;
		 rx_dw_fifo_te : OUT STD_LOGIC;
		 tx_dw_fifo_te : OUT STD_LOGIC;
		 tx_fd_fifo_te : OUT STD_LOGIC;
		 i2c_test_en : OUT STD_LOGIC;
		 token_test_en : OUT STD_LOGIC;
		 scl_test : OUT STD_LOGIC;
		 sdain_test : OUT STD_LOGIC;
		 token_test : OUT STD_LOGIC;
		 ec_test_en : OUT STD_LOGIC;
		 ec_test : OUT STD_LOGIC;
		 ec_test_sel : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ed_flf_data_in : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 ed_vlf_data_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ee_flf_data_in : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		 ee_vlf_data_in : OUT STD_LOGIC_VECTOR(10 DOWNTO 0);
		 flf_data_out : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		 rx_dw_fifo_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_fd_fifo_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_dw_fifo_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_fd_fifo_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_flf_data_in : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 tx_vlf_data_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 vlf_data_out : OUT STD_LOGIC_VECTOR(10 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vlf_dec_rh
	PORT(clk : IN STD_LOGIC;
		 vlf_data_valid : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 init : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reg_init_a : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 reg_init_b : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 reg_init_c : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 vlf_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 e1_out : OUT STD_LOGIC;
		 e2_out : OUT STD_LOGIC;
		 e3_out : OUT STD_LOGIC;
		 e4_out : OUT STD_LOGIC;
		 e5_out : OUT STD_LOGIC;
		 e6_out : OUT STD_LOGIC;
		 ta1_out : OUT STD_LOGIC;
		 ta2_out : OUT STD_LOGIC;
		 ta3_out : OUT STD_LOGIC;
		 tb1_out : OUT STD_LOGIC;
		 tb2_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT vlf_enc_rh
	PORT(e1_in : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 e2_in : IN STD_LOGIC;
		 e3_in : IN STD_LOGIC;
		 e4_in : IN STD_LOGIC;
		 e5_in : IN STD_LOGIC;
		 e6_in : IN STD_LOGIC;
		 ta1_in : IN STD_LOGIC;
		 ta2_in : IN STD_LOGIC;
		 ta3_in : IN STD_LOGIC;
		 tb1_in : IN STD_LOGIC;
		 tb2_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ta_delay_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ta_delay_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ta_delay_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 vlf_data_valid : OUT STD_LOGIC;
		 vlf_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	bus_ec_test_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ctrl_reg_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ctrl_reg_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ctrl_reg_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_out_reg_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_out_reg_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_out_reg_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_reg_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_reg_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_sel_reg_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_test :  STD_LOGIC;
SIGNAL	ec_test_en :  STD_LOGIC;
SIGNAL	ec_test_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_test_out_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_test_out_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_test_out_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_test_sel :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ed_flf_data_in :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	ed_flf_data_out :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	ed_flf_dv_in :  STD_LOGIC;
SIGNAL	ed_vlf_data_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	ed_vlf_data_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ed_vlf_dv_in :  STD_LOGIC;
SIGNAL	ee_flf_data_in :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	ee_flf_data_out :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	ee_flf_dv_out :  STD_LOGIC;
SIGNAL	ee_vlf_data_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ee_vlf_data_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	ee_vlf_dv_out :  STD_LOGIC;
SIGNAL	ef_reg_a :  STD_LOGIC_VECTOR(23 DOWNTO 0);
SIGNAL	ef_reg_b :  STD_LOGIC_VECTOR(23 DOWNTO 0);
SIGNAL	ef_reg_c :  STD_LOGIC_VECTOR(23 DOWNTO 0);
SIGNAL	flf_data_in :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	flf_data_out :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	i2c_ec_reset :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_test_en :  STD_LOGIC;
SIGNAL	init :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	reg_init_a :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	reg_init_b :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	reg_init_c :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_dwf_deu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_dwf_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_deu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fd_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_deu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fdf_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_fs_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_sl_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_ths_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	scl_ALTERA_SYNTHESIZED :  STD_LOGIC;
SIGNAL	scl_in :  STD_LOGIC;
SIGNAL	scl_test :  STD_LOGIC;
SIGNAL	sdain_ALTERA_SYNTHESIZED :  STD_LOGIC;
SIGNAL	sdain_in :  STD_LOGIC;
SIGNAL	sdain_test :  STD_LOGIC;
SIGNAL	sdaout_ALTERA_SYNTHESIZED :  STD_LOGIC;
SIGNAL	sync_rx_sl :  STD_LOGIC;
SIGNAL	ta_delay_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ta_delay_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ta_delay_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_delay_a :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_delay_b :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_delay_c :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	test_reg_a :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	test_reg_b :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	test_reg_c :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	token :  STD_LOGIC;
SIGNAL	token_in :  STD_LOGIC;
SIGNAL	token_test :  STD_LOGIC;
SIGNAL	token_test_en :  STD_LOGIC;
SIGNAL	tx_dwf_deu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_dwf_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_deu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fdf_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_fs_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_seu_ef :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	vlf_data_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	vlf_data_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	vlf_e4_in :  STD_LOGIC;
SIGNAL	vlf_e4_out :  STD_LOGIC;
SIGNAL	vlf_e5_in :  STD_LOGIC;
SIGNAL	vlf_e5_out :  STD_LOGIC;
SIGNAL	vlf_e6_in :  STD_LOGIC;
SIGNAL	vlf_e6_out :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_17 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_18 :  STD_LOGIC_VECTOR(0 TO 7);
SIGNAL	SYNTHESIZED_WIRE_16 :  STD_LOGIC_VECTOR(0 TO 2);


BEGIN 
SYNTHESIZED_WIRE_17 <= "111";
SYNTHESIZED_WIRE_1 <= "111";
SYNTHESIZED_WIRE_2 <= '0';
SYNTHESIZED_WIRE_18 <= "00000000";
SYNTHESIZED_WIRE_16 <= "111";



b2v_EC_MOD : ff_emu_error_cnt_mod
PORT MAP(ec_test => ec_test,
		 clk => clk,
		 tx_dwf_seu => tx_dwf_seu,
		 rx_dwf_seu => rx_dwf_seu,
		 tx_dwf_deu => tx_dwf_deu,
		 rx_dwf_deu => rx_dwf_deu,
		 tx_fdf_seu => tx_fdf_seu,
		 rx_fdf_seu => rx_fdf_seu,
		 tx_fdf_deu => tx_fdf_deu,
		 rx_fdf_deu => rx_fdf_deu,
		 tx_seu => tx_seu,
		 tx_fs_seu => tx_fs_seu,
		 rx_seu => rx_seu,
		 rx_fs_seu => rx_fs_seu,
		 rx_sl => sync_rx_sl,
		 rx_ths_seu => rx_ths_seu,
		 rx_fd_seu => rx_fd_seu,
		 rx_fd_deu => rx_fd_deu,
		 ec_enable => SYNTHESIZED_WIRE_17,
		 ec_reset => reset,
		 ec_sel_a => ec_sel_a,
		 ec_sel_b => ec_sel_b,
		 ec_sel_c => ec_sel_c,
		 ec_test_en => bus_ec_test_en,
		 ec_out_a => ec_out_reg_a,
		 ec_out_b => ec_out_reg_b,
		 ec_out_c => ec_out_reg_c,
		 ec_test_out_a => ec_test_out_a,
		 ec_test_out_b => ec_test_out_b,
		 ec_test_out_c => ec_test_out_c,
		 rx_dwf_deu_ef => rx_dwf_deu_ef,
		 rx_dwf_seu_ef => rx_dwf_seu_ef,
		 rx_fd_deu_ef => rx_fd_deu_ef,
		 rx_fd_seu_ef => rx_fd_seu_ef,
		 rx_fdf_deu_ef => rx_fdf_deu_ef,
		 rx_fdf_seu_ef => rx_fdf_seu_ef,
		 rx_fs_seu_ef => rx_fs_seu_ef,
		 rx_seu_ef => rx_seu_ef,
		 rx_sl_ef => rx_sl_ef,
		 rx_ths_seu_ef => rx_ths_seu_ef,
		 tx_dwf_deu_ef => tx_dwf_deu_ef,
		 tx_dwf_seu_ef => tx_dwf_seu_ef,
		 tx_fdf_deu_ef => tx_fdf_deu_ef,
		 tx_fdf_seu_ef => tx_fdf_seu_ef,
		 tx_fs_seu_ef => tx_fs_seu_ef,
		 tx_seu_ef => tx_seu_ef);


b2v_FLF_DEC : flf_dec_rh
PORT MAP(clk => clk,
		 flf_data_valid => ed_flf_dv_in,
		 enable => clk_en,
		 flf_data => ed_flf_data_in,
		 reset => reset,
		 p1_out => ed_flf_data_out(0),
		 e1_out => ed_flf_data_out(2),
		 p2_out => ed_flf_data_out(1),
		 e2_out => ed_flf_data_out(3));


b2v_FLF_ENC : flf_enc_rh
PORT MAP(p1_in => ee_flf_data_in(0),
		 p2_in => ee_flf_data_in(1),
		 e1_in => ee_flf_data_in(2),
		 clk => clk_ref,
		 e2_in => ee_flf_data_in(3),
		 enable => SYNTHESIZED_WIRE_1,
		 reset => reset,
		 flf_data_valid => ee_flf_dv_out,
		 flf_data => ee_flf_data_out);


b2v_I2C_SLAVE : ff_emu_i2c_slave
PORT MAP(clk => clk,
		 sdain => sdain_ALTERA_SYNTHESIZED,
		 scl => scl_ALTERA_SYNTHESIZED,
		 ch_addr => SYNTHESIZED_WIRE_2,
		 i2c_reg_10_a => ef_reg_a(23 DOWNTO 16),
		 i2c_reg_10_b => ef_reg_b(23 DOWNTO 16),
		 i2c_reg_10_c => ef_reg_c(23 DOWNTO 16),
		 i2c_reg_11_a => ec_out_reg_a,
		 i2c_reg_11_b => ec_out_reg_b,
		 i2c_reg_11_c => ec_out_reg_c,
		 i2c_reg_12_a => SYNTHESIZED_WIRE_18,
		 i2c_reg_12_b => SYNTHESIZED_WIRE_18,
		 i2c_reg_12_c => SYNTHESIZED_WIRE_18,
		 i2c_reg_13_a => SYNTHESIZED_WIRE_18,
		 i2c_reg_13_b => SYNTHESIZED_WIRE_18,
		 i2c_reg_13_c => SYNTHESIZED_WIRE_18,
		 i2c_reg_14_a => SYNTHESIZED_WIRE_18,
		 i2c_reg_14_b => SYNTHESIZED_WIRE_18,
		 i2c_reg_14_c => SYNTHESIZED_WIRE_18,
		 i2c_reg_15_a => SYNTHESIZED_WIRE_18,
		 i2c_reg_15_b => SYNTHESIZED_WIRE_18,
		 i2c_reg_15_c => SYNTHESIZED_WIRE_18,
		 i2c_reg_8_a => ef_reg_a(7 DOWNTO 0),
		 i2c_reg_8_b => ef_reg_b(7 DOWNTO 0),
		 i2c_reg_8_c => ef_reg_c(7 DOWNTO 0),
		 i2c_reg_9_a => ef_reg_a(15 DOWNTO 8),
		 i2c_reg_9_b => ef_reg_b(15 DOWNTO 8),
		 i2c_reg_9_c => ef_reg_c(15 DOWNTO 8),
		 i2c_reset => reset,
		 sdaouten => sdaouten,
		 sdaout => sdaout_ALTERA_SYNTHESIZED,
		 i2c_reg_0_a => ctrl_reg_a,
		 i2c_reg_0_b => ctrl_reg_b,
		 i2c_reg_0_c => ctrl_reg_c,
		 i2c_reg_1_a => ta_delay_a,
		 i2c_reg_1_b => ta_delay_b,
		 i2c_reg_1_c => ta_delay_c,
		 i2c_reg_2_a => tb_delay_a,
		 i2c_reg_2_b => tb_delay_b,
		 i2c_reg_2_c => tb_delay_c,
		 i2c_reg_3_a => reg_init_a(7 DOWNTO 0),
		 i2c_reg_3_b => reg_init_b(7 DOWNTO 0),
		 i2c_reg_3_c => reg_init_c(7 DOWNTO 0),
		 i2c_reg_4_a => reg_init_a(15 DOWNTO 8),
		 i2c_reg_4_b => reg_init_b(15 DOWNTO 8),
		 i2c_reg_4_c => reg_init_c(15 DOWNTO 8),
		 i2c_reg_5_a => ec_sel_reg_a,
		 i2c_reg_5_b => ec_sel_reg_b,
		 i2c_reg_5_c => ec_sel_reg_c);


vlf_data_in(0) <= vlf_e1_in;


vlf_data_in(1) <= vlf_e2_in;


vlf_data_in(2) <= vlf_e3_in;


vlf_data_in(3) <= vlf_ta1_in;


vlf_data_in(4) <= vlf_ta2_in;


vlf_data_in(5) <= vlf_ta3_in;


vlf_data_in(6) <= vlf_tb1_in;


vlf_data_in(7) <= vlf_tb2_in;


vlf_data_in(8) <= vlf_e4_in;



vlf_data_in(9) <= vlf_e5_in;


vlf_data_in(10) <= vlf_e6_in;


flf_data_in(0) <= flf_p1_in;


flf_data_in(1) <= flf_p2_in;


flf_data_in(2) <= flf_e1_in;


flf_data_in(3) <= flf_e2_in;


vlf_e1_out <= vlf_data_out(0);


vlf_e2_out <= vlf_data_out(1);


vlf_e3_out <= vlf_data_out(2);


vlf_ta1_out <= vlf_data_out(3);



vlf_ta2_out <= vlf_data_out(4);


vlf_ta3_out <= vlf_data_out(5);


vlf_tb1_out <= vlf_data_out(6);


vlf_tb2_out <= vlf_data_out(7);


vlf_e4_out <= vlf_data_out(8);


vlf_e5_out <= vlf_data_out(9);


vlf_e6_out <= vlf_data_out(10);


flf_p1_out <= flf_data_out(0);


flf_p2_out <= flf_data_out(1);


flf_e1_out <= flf_data_out(2);


scl_in <= vlf_e5_out;


flf_e2_out <= flf_data_out(3);


token_in <= vlf_e4_out;


vlf_e4_in <= token;


init(0) <= ctrl_reg_a(0);



b2v_inst44 : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => i2c_test_en,
		 data0(0) => scl_in,
		 data1(0) => scl_test,
		 result(0) => scl_ALTERA_SYNTHESIZED);


b2v_inst45 : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => i2c_test_en,
		 data0(0) => sdain_in,
		 data1(0) => sdain_test,
		 result(0) => sdain_ALTERA_SYNTHESIZED);


b2v_inst46 : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => token_test_en,
		 data0(0) => token_in,
		 data1(0) => token_test,
		 result(0) => token);


b2v_inst47 : vl_n
GENERIC MAP(n => 8
			)
PORT MAP(data_a_in => ec_test_out_a,
		 data_b_in => ec_test_out_b,
		 data_c_in => ec_test_out_c,
		 data_out => ec_test_out);

bus_ec_test_en(0) <= ec_test_en;


bus_ec_test_en(1) <= ec_test_en;


sdain_in <= vlf_e6_out;


bus_ec_test_en(2) <= ec_test_en;


init(1) <= ctrl_reg_b(0);


init(2) <= ctrl_reg_c(0);



b2v_inst53 : mux_2xn
GENERIC MAP(n => 8
			)
PORT MAP(sel => ec_test_en,
		 data0 => ec_sel_reg_a,
		 data1 => ec_test_sel,
		 result => ec_sel_a);


b2v_inst54 : mux_2xn
GENERIC MAP(n => 8
			)
PORT MAP(sel => ec_test_en,
		 data0 => ec_sel_reg_b,
		 data1 => ec_test_sel,
		 result => ec_sel_b);


b2v_inst55 : mux_2xn
GENERIC MAP(n => 8
			)
PORT MAP(sel => ec_test_en,
		 data0 => ec_sel_reg_c,
		 data1 => ec_test_sel,
		 result => ec_sel_c);

token_out <= token;





vlf_e5_in <= scl_ALTERA_SYNTHESIZED;


vlf_e6_in <= sdaout_ALTERA_SYNTHESIZED;





b2v_NA_MOD : net_assignment_mod
PORT MAP(rx_dwf_deu_ef => rx_dwf_deu_ef,
		 rx_dwf_seu_ef => rx_dwf_seu_ef,
		 rx_fd_deu_ef => rx_fd_deu_ef,
		 rx_fd_seu_ef => rx_fd_seu_ef,
		 rx_fdf_deu_ef => rx_fdf_deu_ef,
		 rx_fdf_seu_ef => rx_fdf_seu_ef,
		 rx_fs_seu_ef => rx_fs_seu_ef,
		 rx_seu_ef => rx_seu_ef,
		 rx_sl_ef => rx_sl_ef,
		 rx_ths_seu_ef => rx_ths_seu_ef,
		 tx_dwf_deu_ef => tx_dwf_deu_ef,
		 tx_dwf_seu_ef => tx_dwf_seu_ef,
		 tx_fdf_deu_ef => tx_fdf_deu_ef,
		 tx_fdf_seu_ef => tx_fdf_seu_ef,
		 tx_fs_seu_ef => tx_fs_seu_ef,
		 tx_seu_ef => tx_seu_ef,
		 ef_reg_a => ef_reg_a,
		 ef_reg_b => ef_reg_b,
		 ef_reg_c => ef_reg_c);


b2v_SL_SYNC : rx_sl_sync_reg
PORT MAP(rx_sl => rx_sl,
		 clk => clk,
		 enable => SYNTHESIZED_WIRE_17,
		 reset => reset,
		 sync_rx_sl => sync_rx_sl);


b2v_TEST_MOD : test_module
PORT MAP(clk => clk,
		 ee_flf_dv_out => ee_flf_dv_out,
		 ee_vlf_dv_out => ee_vlf_dv_out,
		 rx_flf_dv_out => rx_flf_dv_out,
		 rx_vlf_dv_out => rx_vlf_dv_out,
		 sdaout_test => sdaout_ALTERA_SYNTHESIZED,
		 ec_test_out => ec_test_out,
		 ed_flf_data_out => ed_flf_data_out,
		 ed_vlf_data_out => ed_vlf_data_out,
		 ee_flf_data_out => ee_flf_data_out,
		 ee_vlf_data_out => ee_vlf_data_out,
		 flf_data_in => flf_data_in,
		 mode_sel => mode_sel,
		 rx_dw_fifo_out => rx_dw_fifo_out,
		 rx_fd_fifo_out => rx_fd_fifo_out,
		 rx_flf_data_out => rx_flf_data_out,
		 rx_vlf_data_out => rx_vlf_data_out,
		 tx_dw_fifo_out => tx_dw_fifo_out,
		 tx_fd_fifo_out => tx_fd_fifo_out,
		 vlf_data_in => vlf_data_in,
		 tx_flf_dv_in => tx_flf_dv_in,
		 tx_vlf_dv_in => tx_vlf_dv_in,
		 ed_flf_dv_in => ed_flf_dv_in,
		 ed_vlf_dv_in => ed_vlf_dv_in,
		 tx_dw_fifo_we => tx_dw_fifo_test_wr,
		 tx_dw_fifo_re => tx_dw_fifo_test_rd,
		 tx_fd_fifo_we => tx_fd_fifo_test_wr,
		 tx_fd_fifo_re => tx_fd_fifo_test_rd,
		 rx_dw_fifo_we => rx_dw_fifo_test_wr,
		 rx_dw_fifo_re => rx_dw_fifo_test_rd,
		 rx_fd_fifo_we => rx_fd_fifo_test_wr,
		 rx_fd_fifo_re => rx_fd_fifo_test_rd,
		 rx_fd_fifo_te => rx_fd_fifo_test_en,
		 rx_dw_fifo_te => rx_dw_fifo_test_en,
		 tx_dw_fifo_te => tx_dw_fifo_test_en,
		 tx_fd_fifo_te => tx_fd_fifo_test_en,
		 i2c_test_en => i2c_test_en,
		 token_test_en => token_test_en,
		 scl_test => scl_test,
		 sdain_test => sdain_test,
		 token_test => token_test,
		 ec_test_en => ec_test_en,
		 ec_test => ec_test,
		 ec_test_sel => ec_test_sel,
		 ed_flf_data_in => ed_flf_data_in,
		 ed_vlf_data_in => ed_vlf_data_in,
		 ee_flf_data_in => ee_flf_data_in,
		 ee_vlf_data_in => ee_vlf_data_in,
		 flf_data_out => flf_data_out,
		 rx_dw_fifo_in => rx_dw_fifo_test_in,
		 rx_fd_fifo_in => rx_fd_fifo_test_in,
		 tx_dw_fifo_in => tx_dw_fifo_test_in,
		 tx_fd_fifo_in => tx_fd_fifo_test_in,
		 tx_flf_data_in => tx_flf_data_in,
		 tx_vlf_data_in => tx_vlf_data_in,
		 vlf_data_out => vlf_data_out);


b2v_VLF_DEC : vlf_dec_rh
PORT MAP(clk => clk,
		 vlf_data_valid => ed_vlf_dv_in,
		 enable => clk_en,
		 init => init,
		 reg_init_a => reg_init_a(8 DOWNTO 0),
		 reg_init_b => reg_init_b(8 DOWNTO 0),
		 reg_init_c => reg_init_c(8 DOWNTO 0),
		 reset => reset,
		 vlf_data => ed_vlf_data_in,
		 e1_out => ed_vlf_data_out(0),
		 e2_out => ed_vlf_data_out(1),
		 e3_out => ed_vlf_data_out(2),
		 e4_out => ed_vlf_data_out(8),
		 e5_out => ed_vlf_data_out(9),
		 e6_out => ed_vlf_data_out(10),
		 ta1_out => ed_vlf_data_out(3),
		 ta2_out => ed_vlf_data_out(4),
		 ta3_out => ed_vlf_data_out(5),
		 tb1_out => ed_vlf_data_out(6),
		 tb2_out => ed_vlf_data_out(7));


b2v_VLF_ENC : vlf_enc_rh
PORT MAP(e1_in => ee_vlf_data_in(0),
		 clk => clk_ref,
		 e2_in => ee_vlf_data_in(1),
		 e3_in => ee_vlf_data_in(2),
		 e4_in => ee_vlf_data_in(8),
		 e5_in => ee_vlf_data_in(9),
		 e6_in => ee_vlf_data_in(10),
		 ta1_in => ee_vlf_data_in(3),
		 ta2_in => ee_vlf_data_in(4),
		 ta3_in => ee_vlf_data_in(5),
		 tb1_in => ee_vlf_data_in(6),
		 tb2_in => ee_vlf_data_in(7),
		 enable => SYNTHESIZED_WIRE_16,
		 reset => reset,
		 ta_delay_a => ta_delay_a,
		 ta_delay_b => ta_delay_b,
		 ta_delay_c => ta_delay_c,
		 tb_delay_a => tb_delay_a,
		 tb_delay_b => tb_delay_b,
		 tb_delay_c => tb_delay_c,
		 vlf_data_valid => ee_vlf_dv_out,
		 vlf_data => ee_vlf_data_out);

scl <= scl_ALTERA_SYNTHESIZED;
sdain <= sdain_ALTERA_SYNTHESIZED;
sdaout <= sdaout_ALTERA_SYNTHESIZED;

END bdf_type;