-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Tue Jun 28 22:20:00 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_emu_core IS 
	PORT
	(
		vlf_e1_in :  IN  STD_LOGIC;
		vlf_e2_in :  IN  STD_LOGIC;
		vlf_e3_in :  IN  STD_LOGIC;
		vlf_ta1_in :  IN  STD_LOGIC;
		vlf_ta2_in :  IN  STD_LOGIC;
		vlf_ta3_in :  IN  STD_LOGIC;
		vlf_tb1_in :  IN  STD_LOGIC;
		vlf_tb2_in :  IN  STD_LOGIC;
		flf_p1_in :  IN  STD_LOGIC;
		flf_p2_in :  IN  STD_LOGIC;
		flf_e1_in :  IN  STD_LOGIC;
		flf_e2_in :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		clk_ref :  IN  STD_LOGIC;
		rx_flf_dv_out :  IN  STD_LOGIC;
		rx_vlf_dv_out :  IN  STD_LOGIC;
		tx_tkn :  IN  STD_LOGIC;
		tx_sda :  IN  STD_LOGIC;
		tx_scl :  IN  STD_LOGIC;
		clk_en_in :  IN  STD_LOGIC;
		reset_in :  IN  STD_LOGIC;
		reg_init :  IN  STD_LOGIC_VECTOR(8 DOWNTO 0);
		rx_flf_data_out :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		rx_vlf_data_out :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		ta_delay :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tb_delay :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		flf_p1_out :  OUT  STD_LOGIC;
		flf_p2_out :  OUT  STD_LOGIC;
		flf_e1_out :  OUT  STD_LOGIC;
		flf_e2_out :  OUT  STD_LOGIC;
		vlf_e1_out :  OUT  STD_LOGIC;
		vlf_e3_out :  OUT  STD_LOGIC;
		vlf_e2_out :  OUT  STD_LOGIC;
		vlf_ta1_out :  OUT  STD_LOGIC;
		vlf_ta2_out :  OUT  STD_LOGIC;
		vlf_ta3_out :  OUT  STD_LOGIC;
		vlf_tb1_out :  OUT  STD_LOGIC;
		vlf_tb2_out :  OUT  STD_LOGIC;
		tx_flf_dv_in :  OUT  STD_LOGIC;
		tx_vlf_dv_in :  OUT  STD_LOGIC;
		rx_tkn :  OUT  STD_LOGIC;
		rx_scl :  OUT  STD_LOGIC;
		rx_sda :  OUT  STD_LOGIC;
		tx_flf_data_in :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0);
		tx_vlf_data_in :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END ff_emu_emu_core;

ARCHITECTURE bdf_type OF ff_emu_emu_core IS 

COMPONENT flf_enc_rh
	PORT(p1_in : IN STD_LOGIC;
		 p2_in : IN STD_LOGIC;
		 e1_in : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 e2_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 flf_data_valid : OUT STD_LOGIC;
		 flf_data : OUT STD_LOGIC_VECTOR(5 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_dec_rh
	PORT(clk : IN STD_LOGIC;
		 flf_data_valid : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 flf_data : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 p1_out : OUT STD_LOGIC;
		 e1_out : OUT STD_LOGIC;
		 p2_out : OUT STD_LOGIC;
		 e2_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT vlf_enc_rh
	PORT(e1_in : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 e2_in : IN STD_LOGIC;
		 e3_in : IN STD_LOGIC;
		 e4_in : IN STD_LOGIC;
		 e5_in : IN STD_LOGIC;
		 e6_in : IN STD_LOGIC;
		 ta1_in : IN STD_LOGIC;
		 ta2_in : IN STD_LOGIC;
		 ta3_in : IN STD_LOGIC;
		 tb1_in : IN STD_LOGIC;
		 tb2_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 ta_delay_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ta_delay_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ta_delay_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 vlf_data_valid : OUT STD_LOGIC;
		 vlf_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vlf_dec_rh
	PORT(clk : IN STD_LOGIC;
		 vlf_data_valid : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reg_init_a : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 reg_init_b : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 reg_init_c : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 init : IN STD_LOGIC_VECTOR(2 DOWNTO 0);   --NC
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 vlf_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 e1_out : OUT STD_LOGIC;
		 e2_out : OUT STD_LOGIC;
		 e3_out : OUT STD_LOGIC;
		 e4_out : OUT STD_LOGIC;
		 e5_out : OUT STD_LOGIC;
		 e6_out : OUT STD_LOGIC;
		 ta1_out : OUT STD_LOGIC;
		 ta2_out : OUT STD_LOGIC;
		 ta3_out : OUT STD_LOGIC;
		 tb1_out : OUT STD_LOGIC;
		 tb2_out : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	clk_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);

SIGNAL	flf_data_in :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	ee_flf_data_in :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	ee_flf_dv_out :  STD_LOGIC;
SIGNAL	ee_flf_data_out :  STD_LOGIC_VECTOR(5 DOWNTO 0);

SIGNAL	vlf_data_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ee_vlf_data_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ee_vlf_dv_out :  STD_LOGIC;
SIGNAL	ee_vlf_data_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);

SIGNAL	ed_flf_dv_in :  STD_LOGIC;
SIGNAL	ed_flf_data_in :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	ed_flf_data_out :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	flf_data_out :  STD_LOGIC_VECTOR(3 DOWNTO 0);

SIGNAL	ed_vlf_dv_in :  STD_LOGIC;
SIGNAL	ed_vlf_data_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	ed_vlf_data_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	vlf_data_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);

SIGNAL	reset :  STD_LOGIC_VECTOR(2 DOWNTO 0);

SIGNAL	vlf_e4_in :  STD_LOGIC;
SIGNAL	vlf_e4_out :  STD_LOGIC;
SIGNAL	vlf_e5_in :  STD_LOGIC;
SIGNAL	vlf_e5_out :  STD_LOGIC;
SIGNAL	vlf_e6_in :  STD_LOGIC;
SIGNAL	vlf_e6_out :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(0 TO 2);


BEGIN 
SYNTHESIZED_WIRE_0 <= "111";
SYNTHESIZED_WIRE_1 <= "111";

clk_en(2) <= clk_en_in;
clk_en(1) <= clk_en_in;
clk_en(0) <= clk_en_in;

reset(2) <= reset_in;
reset(1) <= reset_in;
reset(0) <= reset_in;

-- FLF Encoder

flf_data_in(0) <= flf_p1_in;
flf_data_in(1) <= flf_p2_in;
flf_data_in(2) <= flf_e1_in;
flf_data_in(3) <= flf_e2_in;

ee_flf_data_in <= flf_data_in;

b2v_inst51 : flf_enc_rh
PORT MAP(
     p1_in => ee_flf_data_in(0),
		 p2_in => ee_flf_data_in(1),
		 e1_in => ee_flf_data_in(2),
		 e2_in => ee_flf_data_in(3),
		 clk => clk_ref,
		 enable => SYNTHESIZED_WIRE_0,
		 reset => reset,
		 flf_data_valid => ee_flf_dv_out,
		 flf_data => ee_flf_data_out);

tx_flf_dv_in <= ee_flf_dv_out;
tx_flf_data_in <= ee_flf_data_out;

-- VLF Encoder

vlf_e4_in <= tx_tkn;
vlf_e5_in <= tx_scl;
vlf_e6_in <= tx_sda;

vlf_data_in(0) <= vlf_e1_in;
vlf_data_in(1) <= vlf_e2_in;
vlf_data_in(2) <= vlf_e3_in;
vlf_data_in(3) <= vlf_ta1_in;
vlf_data_in(4) <= vlf_ta2_in;
vlf_data_in(5) <= vlf_ta3_in;
vlf_data_in(6) <= vlf_tb1_in;
vlf_data_in(7) <= vlf_tb2_in;
vlf_data_in(8) <= vlf_e4_in;
vlf_data_in(9) <= vlf_e5_in;
vlf_data_in(10) <= vlf_e6_in;

ee_vlf_data_in <= vlf_data_in;

b2v_inst65 : vlf_enc_rh
PORT MAP(
		 clk => clk_ref,
     enable => SYNTHESIZED_WIRE_1,
     reset => reset,
     e1_in => ee_vlf_data_in(0),
		 e2_in => ee_vlf_data_in(1),
		 e3_in => ee_vlf_data_in(2),
		 e4_in => ee_vlf_data_in(8),
		 e5_in => ee_vlf_data_in(9),
		 e6_in => ee_vlf_data_in(10),
		 ta1_in => ee_vlf_data_in(3),
		 ta2_in => ee_vlf_data_in(4),
		 ta3_in => ee_vlf_data_in(5),
		 tb1_in => ee_vlf_data_in(6),
		 tb2_in => ee_vlf_data_in(7),
		 ta_delay_a => ta_delay,
		 ta_delay_b => ta_delay,
		 ta_delay_c => ta_delay,
		 tb_delay_a => tb_delay,
		 tb_delay_b => tb_delay,
		 tb_delay_c => tb_delay,
		 vlf_data_valid => ee_vlf_dv_out,
		 vlf_data => ee_vlf_data_out);

tx_vlf_dv_in <= ee_vlf_dv_out;
tx_vlf_data_in <= ee_vlf_data_out;

-- FLF Decoder

ed_flf_dv_in <= rx_flf_dv_out;
ed_flf_data_in <= rx_flf_data_out;

b2v_inst64 : flf_dec_rh
PORT MAP(clk => clk,
		 flf_data_valid => ed_flf_dv_in,
		 enable => clk_en,
		 flf_data => ed_flf_data_in,
		 reset => reset,
		 p1_out => ed_flf_data_out(0),
		 p2_out => ed_flf_data_out(1),
		 e1_out => ed_flf_data_out(2),
		 e2_out => ed_flf_data_out(3));

flf_data_out <= ed_flf_data_out;

flf_p1_out <= flf_data_out(0);
flf_p2_out <= flf_data_out(1);
flf_e1_out <= flf_data_out(2);
flf_e2_out <= flf_data_out(3);

-- VLF Decoder

ed_vlf_dv_in <= rx_vlf_dv_out;
ed_vlf_data_in <= rx_vlf_data_out;

b2v_inst66 : vlf_dec_rh
PORT MAP(clk => clk,
		 vlf_data_valid => ed_vlf_dv_in,
		 enable => clk_en,
		 reg_init_a => reg_init,
		 reg_init_b => reg_init,
		 reg_init_c => reg_init,
		 reset => reset,
		 init => (OTHERS => '0'),--NC
		 vlf_data => ed_vlf_data_in,
		 e1_out => ed_vlf_data_out(0),
		 e2_out => ed_vlf_data_out(1),
		 e3_out => ed_vlf_data_out(2),
		 e4_out => ed_vlf_data_out(8),
		 e5_out => ed_vlf_data_out(9),
		 e6_out => ed_vlf_data_out(10),
		 ta1_out => ed_vlf_data_out(3),
		 ta2_out => ed_vlf_data_out(4),
		 ta3_out => ed_vlf_data_out(5),
		 tb1_out => ed_vlf_data_out(6),
		 tb2_out => ed_vlf_data_out(7));

vlf_data_out <= ed_vlf_data_out;

vlf_e1_out <= vlf_data_out(0);
vlf_e2_out <= vlf_data_out(1);
vlf_e3_out <= vlf_data_out(2);
vlf_ta1_out <= vlf_data_out(3);
vlf_ta2_out <= vlf_data_out(4);
vlf_ta3_out <= vlf_data_out(5);
vlf_tb1_out <= vlf_data_out(6);
vlf_tb2_out <= vlf_data_out(7);
vlf_e4_out <= vlf_data_out(8);
vlf_e5_out <= vlf_data_out(9);
vlf_e6_out <= vlf_data_out(10);

rx_tkn <= vlf_e4_out;
rx_scl <= vlf_e5_out;
rx_sda <= vlf_e6_out;

END bdf_type;